#include "winglib/wgDialog.h"


#ifndef _WG_AUTOCLEAN_DIALOG
#define _WG_AUTOCLEAN_DIALOG


/// wgAutoCleanDialog is a wgDialog which will clean itself only if you create a modeless Dialog Box. 
/// To correctly use a wgAutoCleanDialog box you <i>must</i> create it on the heap, ie. through
/// the use of the 'new' operator. Do not try to delete the memory when creating a modeless dialog
/// box. It will be automaticallly taken care of. To create a dialog on the stack will create a access violation error 
/// when the end of it's scope is reached. 


class wgAutoCleanDialog : public wgDialog
{
	public:
	
			/// Constructor 1
		wgAutoCleanDialog(int DIALOG_RESOURCE_CODE, HWND hwndParent=NULL);

			/// Constructor 2
		wgAutoCleanDialog(int DIALOG_RESOURCE_CODE, HINSTANCE _hInstance, HWND hwndParent=NULL);

			/// Constructor 3
		wgAutoCleanDialog(LPCTSTR lpTemplate, HINSTANCE _hInstance, HWND hwndParent=NULL);

			/// overridden for internal purposes
		void OnDestroy();

			/// overridden for internal purposes
		LRESULT OnNCDestroy();
};


#endif //_WG_AUTOCLEAN_DIALOG