// fix for mfc
#if defined(WIN32)
	#ifdef _AFXDLL
		#include <afx.h>
	#else
		#include<windows.h>
	#endif
#endif	


#ifndef _BLZ_OBJECT_SPECIFIC_EVENT_CONTROL
#define _BLZ_OBJECT_SPECIFIC_EVENT_CONTROL

///
/// blzObjectSpecificMutexControl is a class designed to automate the 
/// construction of a Object Specific Mutex.
///
class wgObjectSpecificEventControl
{
	public:

		wgObjectSpecificEventControl();
		wgObjectSpecificEventControl(const wgObjectSpecificEventControl& other);

		virtual ~wgObjectSpecificEventControl();

		wgObjectSpecificEventControl& operator=(const wgObjectSpecificEventControl& other);

			/// WaitForSingleObject performs the same function as the function by the same
			/// name in the win32 sdk.
			/// \param	dwMilliseconds time-out interval in milliseconds.
			///			The function returns if the interval elapses, even if 
			///			the object's state is nonsignaled. If dwMilliseconds is zero, the function 
			///			tests the object's state and returns immediately. If dwMilliseconds is INFINITE, 
			///			the function's time-out interval never elapses. 
		DWORD WaitForSingleObject(DWORD dwMilliseconds);
		DWORD Wait10SecForSingleObject() { return (WaitForSingleObject(10000)); }
		DWORD WaitForSingleObject() { return (WaitForSingleObject(INFINITE)); }
		DWORD CheckWaitForSingleObject() { return (WaitForSingleObject(0)); }

			/// The SetEvent function signals the waiting thread
		BOOL SetEvent();

	protected:


	private:

		HANDLE wgObjectSpecificEventControlEvent;
		char* EventName;
};


#endif //_BLZ_OBJECT_SPECIFIC_EVENT_CONTROL

