//#include <wgOleBase.h>

#ifndef _WG_OLE_DISPATCH_INFO
#define _WG_OLE_DISPATCH_INFO


#include "winglib/wgSafeArray.h"
// Using Array

 // maximum number of arguments allowed in a single call: adjust as required.
#define MAX_DISP_ARGS 10
#define DISP_FREEARGS 0x01
#define DISP_NOSHOWEXCEPTIONS 0x02
// use this flag when adding arguments to indicate that the arg
// contents should NOT automatically be freed/released.
#define DISPARG_NOFREEVARIANT 0x01

#define _STRING_BUFFER_1K 1024

 

class wgOleDispatchInfo{

//	friend void wgOleBase::Invoke(IDispatch* objDispatch, LPOLESTR szMember, wgOleDispatchInfo* args, VARIANTARG* pvargReturn, WORD wInvokeAction, WORD wFlags) throw ();

	public:

	// public constructors and destructors

		wgOleDispatchInfo();
		~wgOleDispatchInfo();
	
	// public member functions

		void ClearAllArgs();

		void AddArgumentCommon(LPOLESTR lpszArgName, WORD wFlags, VARTYPE vt);

		bool AddArgumentDispatch(LPOLESTR lpszArgName, WORD wFlags, IDispatch* pdisp);

		bool AddArgumentInt2(LPOLESTR lpszArgName, WORD wFlags, int i);

		bool AddArgumentInt4(LPOLESTR lpszArgName, WORD wFlags, int i);

		bool AddArgumentBool(LPOLESTR	lpszArgName, WORD wFlags, BOOL b);

		bool AddArgumentDouble(LPOLESTR	lpszArgName, WORD wFlags, double d);

		bool AddArgumentError(LPOLESTR lpszArgName, WORD wFlags, SCODE enuError);

		bool AddArgumentVariant(LPOLESTR lpszArgName, WORD wFlags, VARIANT&	lpsz);

		bool AddArgumentSafeArray(LPOLESTR lpszArgName, WORD wFlags, wgSafeArray& lpsz);

		bool AddArgumentCString(LPOLESTR lpszArgName, WORD wFlags, LPOLESTR	lpsz);

		bool AddArgumentBSTR(LPOLESTR lpszArgName, WORD	wFlags, BSTR bstr);

		bool AddArgumentCStringArray(LPOLESTR lpszArgName, WORD wFlags, LPOLESTR* paszStrings, int iCount);

		static void WideCharacterString(wchar_t strBuffer[], int intBufferSize, const std::string& strValue);
		  // conver the specified value into a wide character std::string and return it in the  buffer

		static std::string BSTRToString(BSTR strOriginal); // convert a BSTR into a std::string. A BSTR is a wide-character, lenght-prefixed std::string
	
						// convert the specified wide character std::string into a regular std::string and return it
		static std::string WideCharStringToString(wchar_t strOriginal[]);

		static std::string GetValueAsString(VARIANT* vRet);

		void TestValue();

	private:

	// private member functions

		void ClearVariant(VARIANTARG *pvarg);

		void ReleaseVariant(VARIANTARG *pvarg);

	// private member variables

		int			miArgCount;
		int			miNamedArgCount;
		VARIANTARG	maVargs[MAX_DISP_ARGS];
		LPOLESTR	malpszArgNames[MAX_DISP_ARGS + 1];	// used to hold the argnames for GetIDs
		WORD		mawFlags[MAX_DISP_ARGS];
};






#endif //_WG_OLE_DISPATCH_INFO




