#include "winglib/wgWindow.h"
/////////////////       wgRegion Class      //////////////////////


#ifndef _WG_REGION
#define _WG_REGION
///
/// wgRegion class is the base class to use when you desire to awgch a Region to a 
/// window or control (usually in order to control painting of that window, or it's 
/// appearance in some other way). This class is often used with the WinSute Skin class 
/// to finish off the 'Skinned' look to a window or Control. 
/// 
class wgRegion : public virtual wgWinBase{

	public:
										
										// it is suggested that the coder, uses a tool 
										// which produces a file which can be imported
										// as a resource to be used as region data
										// as creating anything but the most trivial regions
										// is very time consuming!!						
		wgRegion(int REGION_DATA_RESOURCE_CODE, LPCTSTR RESOURCE_TYPE);

		virtual ~wgRegion()=0;
	
	protected:

	// protected member functions

		void InitRegion();
		void repaint(BOOL Erase=FALSE); // erase background before repaint ?

	private:

	// private member variables

		HRGN msrgn;	// deleted on init
		char* mRESOURCE_TYPE;	// temporarily used between constructor and InitRegion
		int mR_RESOURCE_CODE;	// temporarily used between constructor and InitRegion
};


#endif // _WG_REGION




///////////// end of wgRegion class prototype  ////////////////////////

