#include <hash_map>
#include "winglib/wgActionNotifier.h"
#include "winglib/wgWinControl.h"
#ifndef _WIN32_WINNT 
	#define _WIN32_WINNT 0x0400
#endif//_WIN32_WINNT
#include "winglib/wgWindow.h"
#include "winglib/wgObjectSpecificMutexControl.h"

#ifndef _WG_WIN_ABSTRACT_COMBOBOX
#define _WG_WIN_ABSTRACT_COMBOBOX


///
/// wgWinAbstractComboBox is the base class for all types of buttons, Check boxes, and all Button related windows.
///
class wgWinAbstractComboBox : public wgActionNotifier, public wgWinControl, public wgWindow
{
	public:

			/// Constructor
		wgWinAbstractComboBox(const char* _pcharControlID);

			/// You must provide a destructor
		~wgWinAbstractComboBox()=0;

		int GetCursorSelectIndex();
		int GetCount();
		int GetCursorTextLength(const int index);
		int GetCursorText(char* pcharBuffer, const int index, const int len);

		void SetCursorSelectIndex(int index);

	protected:

			/// Create function is used within the derived Create function to actually create the button.
		virtual HWND Create(const char* Label,
							HWND _Parent,
							int x, 
							int y, 
							int nWidth, 
							int nHeight,
							UINT Style) throw (wuException);


	private:
 
	// private member functions

		virtual inline void OnInit(){}
		virtual inline LRESULT OnNCDestroy();
		virtual inline LRESULT OnDestroy();
		virtual inline LRESULT OnPaint();
		virtual inline LRESULT OnOther(UINT message, WPARAM wParam, LPARAM lParam);
		virtual inline LRESULT OnMouseMove(WPARAM wParam, LPARAM lParam);
		virtual inline LRESULT OnMouseLButtonDown(WPARAM wParam, LPARAM lParam);
		virtual inline LRESULT OnMouseLButtonUp(WPARAM wParam, LPARAM lParam);
		virtual inline LRESULT OnMouseRButtonDown(WPARAM wParam, LPARAM lParam);
		virtual inline LRESULT OnMouseRButtonUp(WPARAM wParam, LPARAM lParam);
		virtual inline LRESULT OnCaptureChanged(HWND hwndNewCapture);	///< sent to window loosing
																	///< capture. It recieves HWND of window
																	///< gaining the mouse capture

	// private member variables

		wgObjectSpecificMutexControl AbsMutex;
		
		char* pcharEndTextBuffer;
		int intEndCursorSelectIndex;
		int intEndCount;
		int intEndCursorTextLength;
		int GetTextReturn;

};





#endif//_WG_WIN_ABSTRACT_COMBOBOX

