#include "winglib/wgWinAbstractComboBox.h"

#ifndef _WG_WIN_COMBOBOX
#define _WG_WIN_COMBOBOX

 
///
/// wgWinDropDownList class allows the creation of a child window button without the need for a resource file
///
class wgWinDropDownList : public wgWinAbstractComboBox
{
	public:

			/// Constructor
		wgWinDropDownList(const char* _pcharControlID);

			/// Destructor
		~wgWinDropDownList();

		HWND Create(const char* Label,				///<label or identifier. Use syntax "#num" if identifier
					HWND _Parent,					///< The Parent Window.
					int x,							///< The x (horizontal) position of the Button relative to the window.
					int y,							///< The y (vertical) position of the Button relative to the window.
					int nWidth,		///< The Width of the Button
					int nHeight,	///< The Height of the Button
					UINT Style=CBS_DROPDOWNLIST|CBS_AUTOHSCROLL ///< The Style of the Button
				) throw (wuException);


	protected:

			/// Retrieves the size of the text (cstrText) in character width, and vertical lines
		void GetTextDimensions(const char* cstrText, int& _x, int& _y);
};


#endif//_WG_WIN_COMBOBOX

