

#define _WINSOCKAPI_
#ifndef STRICT
	#define STRICT
#endif
#ifndef _WIN32_WINNT 
	#define _WIN32_WINNT 0x0400
#endif//_WIN32_WINNT

// fix for mfc
#if defined(WIN32)
	#ifdef _AFXDLL
		#include <afx.h>
	#else
		#include<windows.h>
	#endif
#endif	




#ifndef _WINMAKER_BASE
#define _WINMAKER_BASE


///
/// WinMaker_BASE Contains functionality, used in one way or another, 
/// that provides for registration of Simple Windows with the system 
/// registry. This allows the tracking of windows throughout an application.
/// Classes that inherit from WinMaker_BASE include SDialog and WinMaker. 
/// wgWindow class gains use of these functionalities through it's member object WinMaker. 
///

class wgWinMakerBase{

	public:

		wgWinMakerBase();
		~wgWinMakerBase();

		
		/// The WinMaker_BASE::GetNumOpenWindows function returns the number of windows opened, 
		/// for the calling application, created through the WinMaker_BASE class, ie, all Classes 
		/// inheriting from WinMaker_BASE. 
		unsigned int GetNumOpenWindows();

	protected:

	// protected member functions
		
			/// The WinMaker_BASE::update_registry function creates an entry in the system 
			/// registry for the specified window. It also increments the window count for 
			/// the calling application. Using this method allows us to keep track of the number 
			/// of open windows in an application. 
		void update_registry(HWND _hWnd); 

			/// The WinMaker_BASE::unregister_window function looks for a reference to the specified window in the system registry, 
			/// and if it finds it, deletes the reference, and decrements the window count.
			/// Using this method allows us to keep track of the number of open windows in an application. 
		void unregister_window(HWND _hWnd); // unregisters a closing window

		void register_wgWinMaker();
		void unregister_wgWinMaker();

	private:

	// private data members

		DWORD PID; // set in update_registry

		static int key_init;// new member 10/11/02
							// 1 is initial value that it starts off with, 
							// later if in constructor found at more than 1 that means
							// that that isn't the first instance created
							// value incremented during construction of every wgWinMaker

		int windows_created_by_this;

		HANDLE wgWinRegKeyInitMutex; // make multithread safe

};


#endif //_WINMAKER_BASE

///////////////////   end of wgwgWinMakerBase  /////////////

