#ifndef STRICT
	#define STRICT
#endif
#ifndef _WIN32_WINNT 
	#define _WIN32_WINNT 0x0400
#endif//_WIN32_WINNT
// fix for mfc
#if defined(WIN32)
	#ifdef _AFXDLL
		#include <afx.h>
	#else
		#include<windows.h>
	#endif
#endif	
#include "winglib/wgWinMenuComponent.h"
#include "winglib/wgWinBase.h"

#ifndef _WG_WIN_MENUBAR
#define _WG_WIN_MENUBAR


class wgWinMenu;


///
/// wgWinMenuBar is the top level menu component. A wgWinMenuBar does not require a label as it will never
/// be seen. To add a wgWinMenuBar to a window, either use the supplied function wgWinMenuBar::AddTo(HWND)
/// or wgWinBase::Add(wgWinMenuComponent&).
///
class wgWinMenuBar : public wgWinMenuComponent
{
	friend BOOL wgWinBase::Add(wgWinMenuBar &MenuBar);

	public:

			/// default constructor
		wgWinMenuBar();

			/// Create a Menu Bar with the specified Identifier
		wgWinMenuBar(unsigned int uintIdentifier);
		
		virtual ~wgWinMenuBar();

			/// Add the specified component to this MenuBar, at the specified Position, or with the 
			/// specified position identifier.
		BOOL Add(wgWinMenuComponent* Menu, int Item=-1, BOOL fByPosition=TRUE);

			/// The AddTo function allows the addition of this menu bar to the specified window 
		BOOL AddTo(HWND _hWnd);

		HMENU GetMenu();

		BOOL DestroyMenu();

	protected:

		wgWinMenuBar(std::string strText);
		wgWinMenuBar(std::string strText, unsigned int uintIdentifier);

		HMENU MenuBar;

};



#endif//_WG_WIN_MENUBAR
