
#ifndef WG_WIN_TRAY_ICON
#define WG_WIN_TRAY_ICON

#ifndef STRICT
	#define STRICT
#endif//STRICT
#ifndef WIN32_LEAN_AND_MEAN
	#define WIN32_LEAN_AND_MEAN
#endif//WIN32_LEAN_AND_MEAN
#ifndef _WIN32_WINNT 
	#define _WIN32_WINNT 0x0400
#endif//_WIN32_WINNT
// fix for mfc
#if defined(WIN32)
	#ifdef _AFXDLL
		#include <afx.h>
	#else
		#include<windows.h>
	#endif
#endif	
#include <shellapi.h>



class wgWinTrayIcon
{
	public:

			///default constructor
		wgWinTrayIcon(void);  

			/// Main Constructor
		wgWinTrayIcon(	const HWND hwnd,	///< The handle to the window that should
										///< receive the window messages from the 
										///< system tray menu.
					const UINT uMsg,	///< Application-defined message identifier.
										///< The system uses this identifier for 
										///< notification messages that it sends to the 
										///< window specified by hwnd. These notifications
										///< are sent when a mouse event occurs in the
										///< bounding rectangle of the icon.
					const UINT uID, 
					const HICON hIcon, 
					const char* pTip
				);    

			///destructor
		~wgWinTrayIcon(void); 

			/// Initialise
		void Init(	const HWND hwnd, 	///< The handle to the window that should
										///< receive the window messages from the 
										///< system tray menu.
					const UINT uMsg, 	///< Application-defined message identifier.
										///< The system uses this identifier for 
										///< notification messages that it sends to the 
										///< window specified by hwnd. These notifications
										///< are sent when a mouse event occurs in the
										///< bounding rectangle of the icon.
					const UINT uID, 
					const HICON hIcon, 
					const char* pTip
				);

			/// Add icon to system tray
		void AddToTray(void);
		     
			/// remove icon from system tray
		void RemoveFromTray(void);  

			/// Change the icon currently shown
		void Modify(const HICON hIcon); 

			/// Change the tool-tip that currently applies.
		void Modify(const char* pTip);  

	private:

		NOTIFYICONDATA Data;	//trayicon data structure
		unsigned uTrayed;		///< indicates, if icon is in the tray
};

#endif//WG_WIN_TRAY_ICON
