


#ifndef _WU_CALENDAR_DEFS
#define _WU_CALENDAR_DEFS


// constant timespan codes.
typedef enum
{
	tsSec,
	tsMin,
	tsHour,
	tsDay,
	tsWeek

} wuTimeSpan;







// Country codes sourced from http://worldatlas.com/aatlas/ctycodes.htm


typedef enum
{
	a2AE,	//	UNITED ARAB EMIRATES
	a2AF,	//	AFGHANISTAN
	a2AL,	//	ALBANIA
	a2AM,	//	ARMENIA
	a2SA,	//	SAUDI ARABIA
	a2AO,	//	ANGOLA
	a2AR,	//	ARGENTINA
	a2AU,	//	AUSTRALIA
	a2AW,	//	ARUBA
	a2AZ,	//	AZERBAIJAN
	a2BA,	//	BOSNIA AND HERZEGOWINA
	a2BB,	//	BARBADOS
	a2BD,	//	BANGLADESH
	a2BG,	//	BULGARIA
	a2BH,	//	BAHRAIN
	a2BI,	//	BURUNDI
	a2BM,	//	BERMUDA
	a2BN,	//	BRUNEI DARUSSALAM
	a2BO,	//	BOLIVIA
	a2BR,	//	BRAZIL
	a2BS,	//	BAHAMAS
	a2BT,	//	BHUTAN
	a2BW,	//	BOTSWANA
	a2BY,	//	BELARUS
	a2BZ,	//	BELIZE
	a2CA,	//	CANADA
	a2CD,	//	CONGO, THE DEMOCRATIC REPUBLIC OF THE
	a2CH,	//	SWITZERLAND
	a2CL,	//	CHILE
	a2CN,	//	CHINA
	a2CO,	//	COLOMBIA
	a2CR,	//	COSTA RICA
	a2CU,	//	CUBA
	a2CV,	//	CAPE VERDE
	a2CY,	//	CYPRUS
	a2CZ,	//	CZECH REPUBLIC
	a2DJ,	//	DJIBOUTI
	a2DK,	//	DENMARK
	a2DO,	//	DOMINICAN REPUBLIC
	a2DZ,	//	ALGERIA
	a2EE,	//	ESTONIA
	a2EG,	//	EGYPT
	a2ET,	//	ETHIOPIA
	a2EU,	//	Europe
	a2FJ,	//	FIJI
	a2FK,	//	FALKLAND ISLANDS (MALVINAS)
	a2GB,	//	UNITED KINGDOM
	a2GE,	//	GEORGIA
	a2GH,	//	GHANA
	a2GI,	//	GIBRALTAR
	a2GM,	//	GAMBIA
	a2GN,	//	GUINEA
	a2GT,	//	GUATEMALA
	a2GY,	//	GUYANA
	a2HK,	//	HONG KONG
	a2HN,	//	HONDURAS
	a2HR,	//	CROATIA (local name: Hrvatska)
	a2HT,	//	HAITI
	a2HU,	//	HUNGARY
	a2ID,	//	INDONESIA
	a2IL,	//	ISRAEL
	a2IN,	//	INDIA
	a2IQ,	//	IRAQ
	a2IR,	//	IRAN (ISLAMIC REPUBLIC OF)
	a2IS,	//	ICELAND
	a2JM,	//	JAMAICA
	a2JO,	//	JORDAN
	a2JP,	//	JAPAN
	a2KE,	//	KENYA
	a2KG,	//	KYRGYZSTAN
	a2KH,	//	CAMBODIA
	a2KM,	//	COMOROS
	a2KR,	//	KOREA, REPUBLIC OF
	a2KW,	//	KUWAIT
	a2KY,	//	CAYMAN ISLANDS
	a2KZ,	//	KAZAKHSTAN
	a2LA,	//	LAO PEOPLE'S DEMOCRATIC REPUBLIC
	a2LB,	//	LEBANON
	a2LK,	//	SRI LANKA
	a2LR,	//	LIBERIA
	a2LS,	//	LESOTHO
	a2LT,	//	LITHUANIA
	a2LV,	//	LATVIA
	a2LY,	//	LIBYAN ARAB JAMAHIRIYA
	a2MA,	//	MOROCCO
	a2MD,	//	MOLDOVA, REPUBLIC OF
	a2MG,	//	MADAGASCAR
	a2MK,	//	MACEDONIA, THE FORMER YUGOSLAV REPUBLIC
	a2MM,	//	MYANMAR (Burma)
	a2MN,	//	MONGOLIA
	a2MO,	//	MACAU
	a2MR,	//	MAURITANIA
	a2MT,	//	MALTA
	a2MU,	//	MAURITIUS
	a2MV,	//	MALDIVES
	a2MW,	//	MALAWI
	a2MX,	//	MEXICO
	a2MY,	//	MALAYSIA
	a2MZ,	//	MOZAMBIQUE
	a2NA,	//	NAMIBIA
	a2NG,	//	NIGERIA
	a2NI,	//	NICARAGUA
	a2NO,	//	NORWAY
	a2NP,	//	NEPAL
	a2NZ,	//	NEW ZEALAND
	a2OM,	//	OMAN
	a2PA,	//	PANAMA
	a2PE,	//	PERU
	a2PG,	//	PAPUA NEW GUINEA
	a2PH,	//	PHILIPPINES
	a2PK,	//	PAKISTAN
	a2PL,	//	POLAND
	a2PY,	//	PARAGUAY
	a2QA,	//	QATAR
	a2RO,	//	ROMANIA
	a2RU,	//	RUSSIAN FEDERATION
	a2RW,	//	RWANDA
	a2SB,	//	SOLOMON ISLANDS
	a2SD,	//	SUDAN
	a2SE,	//	SWEDEN
	a2SG,	//	SINGAPORE
	a2SL,	//	SIERRA LEONE
	a2SI,	//	SLOVENIA
	a2SK,	//	SLOVAKIA (Slovak Republic)
	a2SR,	//	SURINAME
	a2ST,	//	SAO TOME AND PRINCIPE
	a2SV,	//	EL SALVADOR
	a2SY,	//	SYRIAN ARAB REPUBLIC
	a2SZ,	//	SWAZILAND
	a2TH,	//	THAILAND
	a2TM,	//	TURKMENISTAN
	a2TN,	//	TUNISIA
	a2TO,	//	TONGA
	a2TR,	//	TURKEY
	a2TT,	//	TRINIDAD AND TOBAGO
	a2TV,	//	TUVALU
	a2TW,	//	TAIWAN, PROVINCE OF CHINA
	a2TZ,	//	TANZANIA, UNITED REPUBLIC OF
	a2UA,	//	UKRAINE
	a2UG,	//	UGANDA
	a2US,	//	UNITED STATES
	a2UY,	//	URUGUAY
	a2UZ,	//	UZBEKISTAN
	a2VE,	//	VENEZUELA
	a2VN,	//	VIET NAM
	a2VU,	//	VANUATU
	a2CM,	//	CAMEROON
	a2DM,	//	DOMINICA
	a2NE,	//	NIGER
	a2PF,	//	FRENCH POLYNESIA
	a2YE,	//	YEMEN
	a2ZA,	//	SOUTH AFRICA
	a2ZM,	//	ZAMBIA
	a2ZW,	//	ZIMBABWE


}a2CountryCode;




typedef enum
{
	a3ARE,	//	UNITED ARAB EMIRATES
	a3AFG,	//	AFGHANISTAN
	a3ALB,	//	ALBANIA
	a3ARM,	//	ARMENIA
	a3SAU,	//	SAUDI ARABIA
	a3AGO,	//	ANGOLA
	a3ARG,	//	ARGENTINA
	a3AUS,	//	AUSTRALIA
	a3ABW,	//	ARUBA
	a3AZE,	//	AZERBAIJAN
	a3BIH,	//	BOSNIA AND HERZEGOWINA
	a3BRB,	//	BARBADOS
	a3BGD,	//	BANGLADESH
	a3BGR,	//	BULGARIA
	a3BHR,	//	BAHRAIN
	a3BDI,	//	BURUNDI
	a3BMU,	//	BERMUDA
	a3BRN,	//	BRUNEI DARUSSALAM
	a3BOL,	//	BOLIVIA
	a3BRA,	//	BRAZIL
	a3BHS,	//	BAHAMAS
	a3BTN,	//	BHUTAN
	a3BWA,	//	BOTSWANA
	a3BLR,	//	BELARUS
	a3BLZ,	//	BELIZE
	a3CAN,	//	CANADA
	a3COD,	//	CONGO, THE DEMOCRATIC REPUBLIC OF THE
	a3CHE,	//	SWITZERLAND
	a3CHL,	//	CHILE
	a3CHN,	//	CHINA
	a3COL,	//	COLOMBIA
	a3CRI,	//	COSTA RICA
	a3CUB,	//	CUBA
	a3CPV,	//	CAPE VERDE
	a3CYP,	//	CYPRUS
	a3CZE,	//	CZECH REPUBLIC
	a3DJI,	//	DJIBOUTI
	a3DNK,	//	DENMARK
	a3DOM,	//	DOMINICAN REPUBLIC
	a3DZA,	//	ALGERIA
	a3EST,	//	ESTONIA
	a3EGY,	//	EGYPT
	a3ETH,	//	ETHIOPIA
	a3EUR,	//	Europe
	a3FJI,	//	FIJI
	a3FLK,	//	FALKLAND ISLANDS (MALVINAS)
	a3GBR,	//	UNITED KINGDOM
	a3GEO,	//	GEORGIA
	a3GHA,	//	GHANA
	a3GIB,	//	GIBRALTAR
	a3GMB,	//	GAMBIA
	a3GIN,	//	GUINEA
	a3GTM,	//	GUATEMALA
	a3GUY,	//	GUYANA
	a3HKG,	//	HONG KONG
	a3HND,	//	HONDURAS
	a3HRV,	//	CROATIA (local name: Hrvatska)
	a3HTI,	//	HAITI
	a3HUN,	//	HUNGARY
	a3IDN,	//	INDONESIA
	a3ISR,	//	ISRAEL
	a3IND,	//	INDIA
	a3IRQ,	//	IRAQ
	a3IRN,	//	IRAN (ISLAMIC REPUBLIC OF)
	a3ISL,	//	ICELAND
	a3JAM,	//	JAMAICA
	a3JOR,	//	JORDAN
	a3JPN,	//	JAPAN
	a3KEN,	//	KENYA
	a3KGZ,	//	KYRGYZSTAN
	a3KHM,	//	CAMBODIA
	a3COM,	//	COMOROS
	a3KOR,	//	KOREA, REPUBLIC OF
	a3KWT,	//	KUWAIT
	a3CYM,	//	CAYMAN ISLANDS
	a3KAZ,	//	KAZAKHSTAN
	a3LAO,	//	LAO PEOPLE'S DEMOCRATIC REPUBLIC
	a3LBN,	//	LEBANON
	a3LKA,	//	SRI LANKA
	a3LBR,	//	LIBERIA
	a3LSO,	//	LESOTHO
	a3LTU,	//	LITHUANIA
	a3LVA,	//	LATVIA
	a3LBY,	//	LIBYAN ARAB JAMAHIRIYA
	a3MAR,	//	MOROCCO
	a3MDA,	//	MOLDOVA, REPUBLIC OF
	a3MDG,	//	MADAGASCAR
	a3MKD,	//	MACEDONIA, THE FORMER YUGOSLAV REPUBLIC
	a3MMR,	//	MYANMAR (Burma)
	a3MNG,	//	MONGOLIA
	a3MAC,	//	MACAU
	a3MRT,	//	MAURITANIA
	a3MLT,	//	MALTA
	a3MUS,	//	MAURITIUS
	a3MDV,	//	MALDIVES
	a3MWI,	//	MALAWI
	a3MEX,	//	MEXICO
	a3MYS,	//	MALAYSIA
	a3MOZ,	//	MOZAMBIQUE
	a3NAM,	//	NAMIBIA
	a3NGA,	//	NIGERIA
	a3NIC,	//	NICARAGUA
	a3NOR,	//	NORWAY
	a3NPL,	//	NEPAL
	a3NZL,	//	NEW ZEALAND
	a3OMN,	//	OMAN
	a3PAN,	//	PANAMA
	a3PER,	//	PERU
	a3PNG,	//	PAPUA NEW GUINEA
	a3PHL,	//	PHILIPPINES
	a3PAK,	//	PAKISTAN
	a3POL,	//	POLAND
	a3PRY,	//	PARAGUAY
	a3QAT,	//	QATAR
	a3ROM,	//	ROMANIA
	a3RUS,	//	RUSSIAN FEDERATION
	a3RWA,	//	RWANDA
	a3SLB,	//	SOLOMON ISLANDS
	a3SDN,	//	SUDAN
	a3SWE,	//	SWEDEN
	a3SGP,	//	SINGAPORE
	a3SLE,	//	SIERRA LEONE
	a3SVN,	//	SLOVENIA
	a3SVK,	//	SLOVAKIA (Slovak Republic)
	a3SUR,	//	SURINAME
	a3STP,	//	SAO TOME AND PRINCIPE
	a3SLV,	//	EL SALVADOR
	a3SYR,	//	SYRIAN ARAB REPUBLIC
	a3SWZ,	//	SWAZILAND
	a3THA,	//	THAILAND
	a3TKM,	//	TURKMENISTAN
	a3TUN,	//	TUNISIA
	a3TON,	//	TONGA
	a3TUR,	//	TURKEY
	a3TTO,	//	TRINIDAD AND TOBAGO
	a3TUV,	//	TUVALU
	a3TWN,	//	TAIWAN, PROVINCE OF CHINA
	a3TZA,	//	TANZANIA, UNITED REPUBLIC OF
	a3UKR,	//	UKRAINE
	a3UGA,	//	UGANDA
	a3USA,	//	UNITED STATES
	a3URY,	//	URUGUAY
	a3UZB,	//	UZBEKISTAN
	a3VEN,	//	VENEZUELA
	a3VNM,	//	VIET NAM
	a3VUT,	//	VANUATU
	a3CMR,	//	CAMEROON
	a3DMA,	//	DOMINICA
	a3NER,	//	NIGER
	a3PYF,	//	FRENCH POLYNESIA
	a3YEM,	//	YEMEN
	a3ZAF,	//	SOUTH AFRICA
	a3ZMB,	//	ZAMBIA
	a3ZWE,	//	ZIMBABWE

}a3CountryCode;



typedef enum
{
	ccyAED,	//	UNITED ARAB EMIRATES
	ccyAFA,	//	AFGHANISTAN
	ccyALL,	//	ALBANIA
	ccyAMD,	//	ARMENIA
	ccyANG,	//	SAUDI ARABIA
	ccyAOA,	//	ANGOLA
	ccyARS,	//	ARGENTINA
	ccyAUD,	//	AUSTRALIA
	ccyAWG,	//	ARUBA
	ccyAZM,	//	AZERBAIJAN
	ccyBAM,	//	BOSNIA AND HERZEGOWINA
	ccyBBD,	//	BARBADOS
	ccyBDT,	//	BANGLADESH
	ccyBGN,	//	BULGARIA
	ccyBHD,	//	BAHRAIN
	ccyBIF,	//	BURUNDI
	ccyBMD,	//	BERMUDA
	ccyBND,	//	BRUNEI DARUSSALAM
	ccyBOB,	//	BOLIVIA
	ccyBRL,	//	BRAZIL
	ccyBSD,	//	BAHAMAS
	ccyBTN,	//	BHUTAN
	ccyBWP,	//	BOTSWANA
	ccyBYR,	//	BELARUS
	ccyBZD,	//	BELIZE
	ccyCAD,	//	CANADA
	ccyCDF,	//	CONGO, THE DEMOCRATIC REPUBLIC OF THE
	ccyCHF,	//	SWITZERLAND
	ccyCLP,	//	CHILE
	ccyCNY,	//	CHINA
	ccyCOP,	//	COLOMBIA
	ccyCRC,	//	COSTA RICA
	ccyCUP,	//	CUBA
	ccyCVE,	//	CAPE VERDE
	ccyCYP,	//	CYPRUS
	ccyCZK,	//	CZECH REPUBLIC
	ccyDJF,	//	DJIBOUTI
	ccyDKK,	//	DENMARK
	ccyDOP,	//	DOMINICAN REPUBLIC
	ccyDZD,	//	ALGERIA
	ccyEEK,	//	ESTONIA
	ccyEGP,	//	EGYPT
	ccyETB,	//	ETHIOPIA
	ccyEUR,	//	Europe
	ccyFJD,	//	FIJI
	ccyFKP,	//	FALKLAND ISLANDS (MALVINAS)
	ccyGBP,	//	UNITED KINGDOM
	ccyGEL,	//	GEORGIA
	ccyGHC,	//	GHANA
	ccyGIP,	//	GIBRALTAR
	ccyGMD,	//	GAMBIA
	ccyGNF,	//	GUINEA
	ccyGTQ,	//	GUATEMALA
	ccyGYD,	//	GUYANA
	ccyHKD,	//	HONG KONG
	ccyHNL,	//	HONDURAS
	ccyHRK,	//	CROATIA (local name: Hrvatska)
	ccyHTG,	//	HAITI
	ccyHUF,	//	HUNGARY
	ccyIDR,	//	INDONESIA
	ccyILS,	//	ISRAEL
	ccyINR,	//	INDIA
	ccyIQD,	//	IRAQ
	ccyIRR,	//	IRAN (ISLAMIC REPUBLIC OF)
	ccyISK,	//	ICELAND
	ccyJMD,	//	JAMAICA
	ccyJOD,	//	JORDAN
	ccyJPY,	//	JAPAN
	ccyKES,	//	KENYA
	ccyKGS,	//	KYRGYZSTAN
	ccyKHR,	//	CAMBODIA
	ccyKMF,	//	COMOROS
	ccyKRW,	//	KOREA, REPUBLIC OF
	ccyKWD,	//	KUWAIT
	ccyKYD,	//	CAYMAN ISLANDS
	ccyKZT,	//	KAZAKHSTAN
	ccyLAK,	//	LAO PEOPLE'S DEMOCRATIC REPUBLIC
	ccyLBP,	//	LEBANON
	ccyLKR,	//	SRI LANKA
	ccyLRD,	//	LIBERIA
	ccyLSL,	//	LESOTHO
	ccyLTL,	//	LITHUANIA
	ccyLVL,	//	LATVIA
	ccyLYD,	//	LIBYAN ARAB JAMAHIRIYA
	ccyMAD,	//	MOROCCO
	ccyMDL,	//	MOLDOVA, REPUBLIC OF
	ccyMGA,	//	MADAGASCAR
	ccyMKD,	//	MACEDONIA, THE FORMER YUGOSLAV REPUBLIC
	ccyMMK,	//	MYANMAR (Burma)
	ccyMNT,	//	MONGOLIA
	ccyMOP,	//	MACAU
	ccyMRO,	//	MAURITANIA
	ccyMTL,	//	MALTA
	ccyMUR,	//	MAURITIUS
	ccyMVR,	//	MALDIVES
	ccyMWK,	//	MALAWI
	ccyMXN,	//	MEXICO
	ccyMYR,	//	MALAYSIA
	ccyMZM,	//	MOZAMBIQUE
	ccyNAD,	//	NAMIBIA
	ccyNGN,	//	NIGERIA
	ccyNIO,	//	NICARAGUA
	ccyNOK,	//	NORWAY
	ccyNPR,	//	NEPAL
	ccyNZD,	//	NEW ZEALAND
	ccyOMR,	//	OMAN
	ccyPAB,	//	PANAMA
	ccyPEN,	//	PERU
	ccyPGK,	//	PAPUA NEW GUINEA
	ccyPHP,	//	PHILIPPINES
	ccyPKR,	//	PAKISTAN
	ccyPLN,	//	POLAND
	ccyPYG,	//	PARAGUAY
	ccyQAR,	//	QATAR
	ccyROL,	//	ROMANIA
	ccyRUB,	//	RUSSIAN FEDERATION
	ccyRWF,	//	RWANDA
	ccySBD,	//	SOLOMON ISLANDS
	ccySDD,	//	SUDAN
	ccySEK,	//	SWEDEN
	ccySGD,	//	SINGAPORE
	ccySHP,	//	SIERRA LEONE
	ccySIT,	//	SLOVENIA
	ccySKK,	//	SLOVAKIA (Slovak Republic)
	ccySRD,	//	SURINAME
	ccySTD,	//	SAO TOME AND PRINCIPE
	ccySVC,	//	EL SALVADOR
	ccySYP,	//	SYRIAN ARAB REPUBLIC
	ccySZL,	//	SWAZILAND
	ccyTHB,	//	THAILAND
	ccyTMM,	//	TURKMENISTAN
	ccyTND,	//	TUNISIA
	ccyTOP,	//	TONGA
	ccyTRL,	//	TURKEY
	ccyTTD,	//	TRINIDAD AND TOBAGO
	ccyTVD,	//	TUVALU
	ccyTWD,	//	TAIWAN, PROVINCE OF CHINA
	ccyTZS,	//	TANZANIA, UNITED REPUBLIC OF
	ccyUAH,	//	UKRAINE
	ccyUGX,	//	UGANDA
	ccyUSD,	//	UNITED STATES
	ccyUYU,	//	URUGUAY
	ccyUZS,	//	UZBEKISTAN
	ccyVEB,	//	VENEZUELA
	ccyVND,	//	VIET NAM
	ccyVUV,	//	VANUATU
	ccyXAF,	//	CAMEROON
	ccyXCD,	//	DOMINICA
	ccyXOF,	//	NIGER
	ccyXPF,	//	FRENCH POLYNESIA
	ccyYER,	//	YEMEN
	ccyZAR,	//	SOUTH AFRICA
	ccyZMK,	//	ZAMBIA
	ccyZWD,	//	ZIMBABWE

}ccyCurrencyCode;





#endif//_WU_CALENDAR_DEFS