#include <string>
#include "winutils/wuStokenizer.h"
#include "winutils/wuStdUtils.h"


#ifndef _FTP_STATE
#define _FTP_STATE

#pragma warning( disable : 4290 ) 




///
///	wuFtpStateCode is a helper class for wuFtpSocket
///
class wuFtpStateCode{

	public:

		wuFtpStateCode(){
	
			intStateCode1=0; // left most digit
			intStateCode2=0; // middle 
			intStateCode3=0; // right most digit
		}

		wuFtpStateCode(const wuFtpStateCode& other){

			intStateCode1=other.intStateCode1; // left most digit
			intStateCode2=other.intStateCode2; // middle 
			intStateCode3=other.intStateCode3; // right most digit
		}

		wuFtpStateCode(unsigned int RawCode){

			ConvertRawCode(RawCode);
		}

		wuFtpStateCode(unsigned int _uintCode1, unsigned int _uintCode2, unsigned int _uintCode3){

			intStateCode1=_uintCode1; // left most digit
			intStateCode2=_uintCode2; // middle 
			intStateCode3=_uintCode3; // right most digit
		}


		wuFtpStateCode& operator=(const wuFtpStateCode& other){

			if (this!=&other){

				intStateCode1=other.intStateCode1; // left most digit
				intStateCode2=other.intStateCode2; // middle 
				intStateCode3=other.intStateCode3; // right most digit
			}

			return *this;
		}

		wuFtpStateCode& operator=(unsigned int RawCode){
	
			ConvertRawCode(RawCode);
			return *this;
		}

		inline bool operator==(const wuFtpStateCode& other){
		
			if	   (intStateCode1==other.intStateCode1 && 
					intStateCode2==other.intStateCode2 &&
					intStateCode3==other.intStateCode3) 
			return true;
			else return false;
		}

		unsigned int intStateCode1; // left most digit
		unsigned int intStateCode2; // middle 
		unsigned int intStateCode3; // right most digit


	private:

		void ConvertRawCode(unsigned int RawCode){

			intStateCode1 = RawCode /100;
			intStateCode2 = (RawCode - (intStateCode1*100)) /10;
			intStateCode3 = (RawCode - (intStateCode1*100) - (intStateCode2*10));
		}

};











class wuFtpState{	/// holds state, and server reply message

	private:

		std::string strMessage;

		wuFtpStateCode fscLastReplyCode;
		int intFtpReplyState; // either ready or waiting for more lines of a multi line reply


		// returns has hyphen true, or has hyphen false, pass by reference the converted code as unsigned integer
		bool GetCode(std::string _strCode, unsigned int& uintCodeNum) throw (exception);


	public:
	
		static const unsigned int _FTP_READY_STATE; // set to 1
		static const unsigned int _FTP_WAITING_STATE;// set to 2


		wuFtpState();
		wuFtpState(std::string _strServerReply) throw (exception);
		wuFtpState(const wuFtpState& other);
		wuFtpState& operator=(const wuFtpState& other);

		int SetState(std::string _strServerReply) throw (exception);
		void Reset();


		// intFtpReplyState will be set anew from here on
		int SetState(std::string _strState, std::string _strMessage) throw (exception);

		inline wuFtpStateCode GetStateCode(){return fscLastReplyCode;}
		inline std::string GetReplyMessage(){return strMessage;}
};








#endif // _FTP_STATE
