#include "winutils/wuTCPSocket.h"



#pragma warning( disable : 4290 ) // warning C4290: C++ Exception Specification ignored

#ifndef _WU_SOCKETS_NOOFERRORCODES
	#define _WU_SOCKETS_NOOFERRORCODES 48
#endif

#ifndef MAXLINE
	#define MAXLINE 4096
#endif


#ifndef _WU_SERVER_SOCKET
#define _WU_SERVER_SOCKET
//////////////////////// ServerSocket wrapper class header //////////////////////////////

///
/// wuServerSocket class allows the creation of Socket objects to setup a port listening for acception 
/// of a client connection. 
///
class wuServerSocket : public wuTCPSocket
{
	public:
		
			/// Constructor. Accepts the local port number for binding as the only argument. 
		wuServerSocket(int intLocalPortNum);

			/// Establish a listening port, and bind to the specified local port number.
		void Establish() throw (wuSocketException);

			/// Reestablish a listening port and bind to that specified port.
		void ReEstablish(int intLocalPortNum) throw (wuSocketException);

			/// Block and wait for a client connection, and return a wuSocket connection once this occurs.
		wuTCPSocket* Accept() throw (wuSocketException);

			/// Close the bound socket. This will cause wuSocketInterrupt exception from Accept() if it is currently
			/// in a blocking state. 
		int CloseListener();
};



#endif//_WU_SERVER_SOCKET

