#include <string>


#ifndef _STOKENIZER
#define _STOKENIZER
 

///
/// wuStokenizer is a simple String Tokenizer class modelled after it's java equivalent.
///
class wuStokenizer 
{
	public:
	
		wuStokenizer::wuStokenizer(std::string to_tokenize, std::string delims, bool _ignore_quotes=false);

		bool more();		///< are more tokens to get ?
		std::string next();	///< get the next token
		std::string NextUntil(char tokEnd, bool including); // create and return a token from current position until 
										// and (including/!including) the nominated character (argument)
										// or until end of string is found
		void restore();		///< restart the tokenizer to intial position
		static std::string toLowerCase(std::string word);
		static std::string toUpperCase(std::string word);
		std::string UnTokenizedString();

			/// returns the delimeters found to the right 
			/// of the string last returned by a call
			/// to next() 
		std::string GetLastDelims(); 
	
		static std::string trim(std::string totrim); // trims all C recognised whitespace from right and left ends


	private:
	
		std::string totok;
		std::string delims;
		std::string lastDelims;
		unsigned int pos;
		int charindelim(const char letter);
		bool IgnoreQuotes;
		bool WithinQuotes;
};



#endif _STOKENIZER
