


// SYSTEM INCLUDES
//

#include "winutils/wuUDPSocket.h"
// PROJECT INCLUDES
//

// LOCAL INCLUDES
//
#include "winutils/wuSysLogger.h"


// FORWARD REFERENCES
//




#ifndef _WU_SYS_LOG_UDP_SOCKET
#define _WU_SYS_LOG_UDP_SOCKET

  


///
/// wuSysLogUDPSocket logs Syslog messages via a UDP connection to a SysLog Server. 
///
class wuSysLogUDPSocket : public wuSysLogger, public wuUDPSocket
{
	public:
		
		wuSysLogUDPSocket();

		wuSysLogUDPSocket(	const char* pcharAppName,
							SysLogSeverityCode LoggingInsignificance,	///< Log from Most Significant until and including the level of Insignificance specified.
							unsigned int uintWinsockSignificantVersNum, 
							unsigned int uintWinsockInsignificantVersNum);
		

			/// Overriden function from wuSysLogger
			/// \param Facility indicates the Facility code as defined in RFC 3164.
			/// \param Severity indicates the Severity code as defined in RFC 3164.
			/// \param cpcharMessageContent is the user defined message to log to the file. This is
			/// used as the CONTENT of the MSG part of a syslog as defined in  RFC 3164.
		bool Log(	SysLogFacilityCode Facility, 
					SysLogSeverityCode Severity, 
					const char* cpcharMessageContent);


			/// Set log file options
		void SetOptions(SysLogSeverityCode	LoggingInsignificance);

	protected:

		bool Log(const char* LogString);

	private:

		HANDLE			mhdlMutex;		// log file mutex

		SysLogSeverityCode mLoggingInsignificance;
};




#endif//_WU_SYS_LOG_UDP_SOCKET




