#include <winglib/wgRegion.h>
#include <winglib/wgWinControl.h>
#include <winglib/wgSkin.h>
#include <commctrl.h>	
		////////  PLEASE INCLUDE Comctl32.lib  in project link settings ////

		////////  PLEASE INCLUDE Comctl32.lib  in project link settings ////



#ifndef _SBUTTON
#define _SBUTTON


#define SMOUSE_OUT 0
#define SMOUSE_OVER 1
#define SMOUSE_DOWN 2


class SButton : public wgWinControl, public wgSkin, public wgRegion
{
	public:

		SButton( int RESOURCE_CODE,		// resource code of button
				 HwgWinBase _Parent,	// Parent of button control
				 int SKIN_CODE,			// Resource code of skin bitmap in SMOUSE_OUT
				 int SKIN_CODE_OVER,	// Resource code of skin bitmap in SMOUSE_OVER, 
										// -NULL to use SMOUSE_OUT state bitmap

				 int SKIN_CODE_DOWN,	// Resource code of skin bitmap in SMOUSE_DOWN,
										// -NULL to use SMOUSE_OUT state bitmap

				 int REGION_CODE,		// resource code of binary resource data
				 LPCTSTR RESOURCE_TYPE, // region resource type eg, "BINARY"
				 int _Width=0,			// desired width, zero means keep current
				 int _Height=0			// desired height, zero means keep current
		)
			:wgWinControl("AButton",RESOURCE_CODE, _Parent, _Width, _Height), 
			 wgSkin(SKIN_CODE, FULL_SKIN),
			 wgRegion(REGION_CODE, RESOURCE_TYPE)
		{
			// discover initial mouse position
			POINT pt;
			HRGN trgn = CreateRectRgn(0, 0, 0, 0);
			GetWindowRgn(hWnd, trgn);
			GetCursorPos(&pt);
			if (PtInRegion(trgn, pt.x, pt.y)) ButtonState=SMOUSE_OVER;
			else ButtonState = SMOUSE_OUT;

			DeleteObject(trgn);

			IMAGE_OVER  = SKIN_CODE_OVER;
			IMAGE_DOWN	= SKIN_CODE_DOWN;
		}



		SButton(HWND _Button,			// HANDLE to button resource
				HwgWinBase _Parent,		// Parent of button control
				int SKIN_CODE,			// Resource code of skin bitmap	in SMOUSE_OUT
				int SKIN_CODE_OVER,		// Resource code of skin bitmap in SMOUSE_OVER
				int SKIN_CODE_DOWN,		// Resource code of skin bitmap in SMOUSE_DOWN
				int REGION_CODE,		// resource code of binary resource data
				LPCTSTR RESOURCE_TYPE,	// region resource type eg, "BINARY"
				int _Width=0,			// desired width, zero means keep current
				int _Height=0			// desired height, zero means keep current
				)
			:wgWinControl("AButton",_Button, _Parent, _Width, _Height),	
			 wgSkin(SKIN_CODE, FULL_SKIN),
			 wgRegion(REGION_CODE, RESOURCE_TYPE)
		{
			// discover initial mouse position
			POINT pt;
			HRGN trgn = CreateRectRgn(0, 0, 0, 0);
			GetWindowRgn(hWnd, trgn);
			GetCursorPos(&pt);
			if (PtInRegion(trgn, pt.x, pt.y)) ButtonState=SMOUSE_OVER;
			else ButtonState = SMOUSE_OUT;

			DeleteObject(trgn);
		}


	private:

	// private member functions

		LRESULT OnPaint();
		void OnInit();
		LRESULT OnMouseMove(WPARAM wParam, LPARAM lParam);
		LRESULT OnMouseLButtonDown(WPARAM wParam, LPARAM lParam);
		LRESULT OnMouseLButtonUp(WPARAM wParam, LPARAM lParam);
		LRESULT OnOther(UINT message, WPARAM wParam, LPARAM lParam);

		// non regular

		LRESULT OnMouseOver();
		LRESULT OnMouseOut();

	// private member variables

		char ButtonState;	// 0 = SMOUSE_OUT and not over, 1 = SMOUSE_OVER, 2 = SMOUSE_DOWN
		int IMAGE_DOWN;
		int IMAGE_OVER;
		HBITMAP ButtonOver;
		HBITMAP ButtonDown;
};

#endif // _SBUTTON