#include "ADialog.h"
#include "resource.h"



ADialog::ADialog()	: wgDialog(IDD_ADIALOG),
					  wgSkin(IDB_SKIN, FULL_SKIN),
					  wgRegion(IDR_REGION, "BINARY")
{	// nothing needed to do here!

}



void ADialog::OnInitDialog(){

	// get ready the text paints
	HDC hdc = GetWindowDC(hWnd);
	GetTextMetrics(hdc, &textInfo);
	ReleaseDC(hWnd, hdc);

	LoadSkin();	
	InitRegion();

	ok = new SButton(IDOK, this, IDB_SBUTTON1, IDB_SBUTTON_OVER, IDB_SBUTTON_DOWN, IDR_SBUTTON, "BINARY" ,81, 69);
	ok->Attach();
}


LRESULT ADialog::OnShowWindow(BOOL fShow, int fnStatus){

	// since it is a dialog, make sure that the size is what we wanted it as.
	SetWindowPos(hWnd, HWND_TOP, 200, 200, 300, 300 ,SWP_SHOWWINDOW);

	return 0;
}




BOOL ADialog::OnCommand(int IDCode, int notifyCode){	// only have this here for exit

	switch(IDCode)
	{
		case IDOK:
			PostMessage(WM_CLOSE, 0, 0);
			return TRUE;
			break;
			  
		default: return FALSE;
	};
}

 


BOOL ADialog::OnOther(UINT message, WPARAM wParam, LPARAM lParam){ // this is here for mouse drag

	switch(message)
	{
		case WM_LBUTTONDOWN:
			SendMessage(WM_NCLBUTTONDOWN, HTCAPTION, NULL); 
			break;

		default: return FALSE;
    };

	return TRUE;
}




LRESULT ADialog::OnPaint(){	// here we paint the skin (bitmap) and then the text message

	// now draw some text over the background 
	PAINTSTRUCT ps;
	HDC hp;
 
	hp = BeginPaint(hWnd, &ps);

	DrawSkin(hp);
	
	SetTextColor(hp, RGB(255, 255, 255));
	SetBkMode(hp, TRANSPARENT);
	TextOut(hp, SWin_Width/4, (int)(SWin_Height*0.55), "WinSute Button Class", 20);
 
	EndPaint(hWnd, &ps);

	return 1;
}


LRESULT ADialog::OnSize(WPARAM wParam, LPARAM lParam)
{ // we need this if resizing the window

	repaint();	// i could comment this out, but haven't bothered!!

	return 1;
}
