#include "SButton.h"


void SButton::OnInit()
{
	InitRegion();	// load regular region
	LoadSkin();		// load regular skin

	// now initialize the other two bitmaps
	ButtonOver  = (HBITMAP)LoadImage(hInstance, MAKEINTRESOURCE(IMAGE_OVER), IMAGE_BITMAP, 0, 0, LR_VGACOLOR);  
	ButtonDown  = (HBITMAP)LoadImage(hInstance, MAKEINTRESOURCE(IMAGE_DOWN), IMAGE_BITMAP, 0, 0, LR_VGACOLOR);  
}



LRESULT SButton::OnPaint(){

	PAINTSTRUCT ps;
	HDC hp;

 	hp = BeginPaint(hWnd, &ps);

	if (ButtonState==SMOUSE_OUT){
		DrawSkin(hp);
	}
	else if (ButtonState==SMOUSE_OVER){
		DrawSkin(hp, ButtonOver);
	}
	else if (ButtonState==SMOUSE_DOWN){
		DrawSkin(hp, ButtonDown);
	}

	EndPaint(hWnd, &ps);

	return 0;
}



LRESULT SButton::OnMouseMove(WPARAM wParam, LPARAM lParam){

	if (ButtonState==SMOUSE_OUT){
		TRACKMOUSEEVENT tme;
		tme.cbSize = sizeof(TRACKMOUSEEVENT);
		tme.dwFlags = TME_LEAVE;
		tme.dwHoverTime = 10;
		tme.hwndTrack = hWnd;
		_TrackMouseEvent(&tme);
		OnMouseOver();
	}

	return 0;
}





LRESULT SButton::OnOther(UINT message, WPARAM wParam, LPARAM lParam){

	switch(message)
	{
		case WM_MOUSELEAVE:
			OnMouseOut();
			break;
	};

	return 1;
}



LRESULT SButton::OnMouseLButtonDown(WPARAM wParam, LPARAM lParam){

	ButtonState=SMOUSE_DOWN;
	repaint();
	return 0;
}



LRESULT SButton::OnMouseLButtonUp(WPARAM wParam, LPARAM lParam){

	ButtonState=SMOUSE_OVER;
	return 0;
}



LRESULT SButton::OnMouseOver(){

	ButtonState=SMOUSE_OVER;
	repaint();

	return 1;
}



LRESULT SButton::OnMouseOut(){

	ButtonState=SMOUSE_OUT;
	repaint();

	return 0;
}
