#ifndef STRICT
	#define STRICT
#endif
#include "winglib/wgWinControl.h"



#ifndef _WG_ACTION_LISTENER
#define _WG_ACTION_LISTENER


/// 
/// Any application that wishes to receive Action Events from wgButtons or wgCheckBox or any other related component
/// must derive from this class and implement the described Action Event Functions.
///
class wgActionListener
{
	public:
	
		wgActionListener();
		virtual ~wgActionListener()=0;

		virtual LRESULT OnMouseMoveAction(WPARAM wParam, LPARAM lParam, wgWinControl*)=0;
		virtual LRESULT OnMouseLButtonDownAction(WPARAM wParam, LPARAM lParam, wgWinControl*)=0;
		virtual LRESULT OnMouseLButtonUpAction(WPARAM wParam, LPARAM lParam, wgWinControl*)=0;
		virtual LRESULT OnMouseRButtonDownAction(WPARAM wParam, LPARAM lParam, wgWinControl*)=0;
		virtual LRESULT OnMouseRButtonUpAction(WPARAM wParam, LPARAM lParam, wgWinControl*)=0;
		virtual LRESULT OnCaptureChangedAction(HWND hwndNewCapture, wgWinControl*)=0;
		virtual LRESULT OnPaintAction(wgWinControl*)=0;
		virtual LRESULT OnNCDestroyAction(wgWinControl*)=0;
		virtual LRESULT OnDestroyAction(wgWinControl*)=0;
		virtual LRESULT OnOtherAction(UINT message, WPARAM wParam, LPARAM lParam, wgWinControl*)=0;
};



#endif//_WG_ACTION_LISTENER
