#include "winglib/wgActionListener.h"

#ifndef _WG_ACTION_NOTIFIER
#define _WG_ACTION_NOTIFIER




class wgNullListener : public wgActionListener
{
	public:

		~wgNullListener(){}

		LRESULT OnMouseMoveAction(WPARAM wParam, LPARAM lParam, wgWinControl*){return 1;}
		LRESULT OnMouseLButtonDownAction(WPARAM wParam, LPARAM lParam, wgWinControl*){return 1;}
		LRESULT OnMouseLButtonUpAction(WPARAM wParam, LPARAM lParam, wgWinControl*){return 1;}
		LRESULT OnMouseRButtonDownAction(WPARAM wParam, LPARAM lParam, wgWinControl*){return 1;}
		LRESULT OnMouseRButtonUpAction(WPARAM wParam, LPARAM lParam, wgWinControl*){return 1;}
		LRESULT OnCaptureChangedAction(HWND hwndNewCapture, wgWinControl*){return 1;}
		LRESULT OnPaintAction(wgWinControl*){return 1;}
		LRESULT OnNCDestroyAction(wgWinControl*){return 1;}
		LRESULT OnDestroyAction(wgWinControl*){return 1;}
		LRESULT OnOtherAction(UINT message, WPARAM wParam, LPARAM lParam, wgWinControl*){return 1;}
};




///
/// wgActionNotifier class is an abstract class that provides functionality to classes that wish to 
/// be a Notifier to ActionListeners. 
///
class wgActionNotifier
{

	public:

		wgActionNotifier();
		virtual ~wgActionNotifier()=0;

			/// An wgActionListener can request to be informed of all Button related Events. Each Event can only
			/// be received by the wgActionListeners if the Button class's OnEvent functions are not derived from. 
			/// In other words, deriving from Button and overriding the OnEvent functions overrides the 
			/// ActionListener notification.
		void SetActionListener(wgActionListener* ActionListener);
		void RemoveActionListener();
		wgActionListener& GetListener();

	private:

		wgActionListener* MyListener;

		wgNullListener ListenVoid;
};
 
#endif //_WG_ACTION_NOTIFIER

