
////////////////////   START OF wgSubclasser Class Prototype   //////////////////

#ifndef _WG_APP_CONTROLLER
#define _WG_APP_CONTROLLER

#include "winglib/wgWindow.h"

///
/// wgSubclasser is a win32 'subclassing' class. In otherwords, 
/// it allows you to take control of a window, given that we know it's HWND.
///
 
class wgSubclasser : public virtual wgWinBase{

	public:

		static const UINT CREATE_APP_SUBCLASSING;

		
		wgSubclasser(HWND _AppWindowHandle, bool _blnRelinquishOnClose=true);
		wgSubclasser(bool _blnRelinquishOnClose=true);

		virtual ~wgSubclasser()=0;

		void Associate(HWND _hWnd);
		void Awgch(); // final --- don't touch
		void RelinquishControl();

		

	protected:

	// protected member functions

		

	// protected member variables
		

	private:

	// private member functions

		static LRESULT CALLBACK ControlProcedure(HWND _hWnd, UINT message, WPARAM wparam, LPARAM lparam);
		void _OnUser(); // this sets up the window, fixed initialization before call to OnInit
	
		virtual inline LRESULT OnOther(UINT message, WPARAM wParam, LPARAM lParam){return 1;}
		virtual inline void OnWindowMessageReturn(UINT message, LPARAM _ReturnCode){}
		virtual inline void OnInit(){}

	// private member variables
	
		LONG OldProc;
		bool Awgched;
		bool blnRelinquishOnClose;
};

#endif // _WG_APP_CONTROLLER




////////////////////      END OF wgSubclasser prototype		////////////////