#include <vector>
#include "winglib/wgDialog.h"



// DESIGN DECISION 1
// decided not to delete each TabDialog until main wgTabControlDialog itself is to be deleted
// done this to make sure there is only one delete point (simplicity sake)
// besides that, killing earlier may cause crashes 


#ifndef _WG_TAB_CONTROL_DIALOG
#define _WG_TAB_CONTROL_DIALOG

class wgTabDialog;


struct TabDialogContainer
{
	TabDialogContainer()
		{
			mpTab = 0;
			mstrTabName = "";
		}

	TabDialogContainer(std::string _strTabName, wgTabDialog* _pTab)
		{
			mpTab = _pTab;
			mstrTabName = _strTabName;
		}

	wgTabDialog* mpTab;
	std::string mstrTabName;
};

typedef std::vector<TabDialogContainer> TabDialogListType;



class wgTabControlDialog : public wgDialog
{
	public:

		wgTabControlDialog(HINSTANCE _hInstance, int _ResourceCode);

		virtual ~wgTabControlDialog();

		HWND Create(DWORD dwStyle=NULL);

		BOOL AddTabDialog(wgTabDialog* hDialog, const char* _TabText);
		BOOL DeleteTabDialog(wgTabDialog* hDialog);
		BOOL DeleteTabDialog(const char* _TabText);
		BOOL DeleteTabDialog(const unsigned int TabIndex);

		virtual void OnDestroy(){} // override this to control close of application 

	protected:

		void OnInitDialog();
		BOOL OnCommand(int IDCode, int notifyCode);
		BOOL OnNotify(int IDCode, NMHDR *hdr);

	private:

	// private member functions
		
		RECT GetBottomTabRect();
		void SetTabDialogSelection(const unsigned int _TabIndex);
		TabDialogListType::iterator FindTab(const char* cpcharTabName);
		void RepositionTabs(int intPositionY);
	// private member variables
		
		HWND hTabWnd; // the actual tab control which dialog's sit upon

		wgTabDialog* CurrentTab;
		TabDialogListType  DialogList;
		int MaxDialogWidth;
		int MaxDialogHeight;
		DWORD dwStyle; // extra style for TabControl .. ie multiline etc
};



#endif //_WG_TAB_CONTROL_DIALOG



