#include "winglib/wgWinAbstractEdit.h"

#ifndef _WG_WIN_EDITBOX
#define _WG_WIN_EDITBOX

 
///
/// wgWinEditBox class allows the creation of a child window button without the need for a resource file
///
class wgWinEditBox : public wgWinAbstractEdit
{
	public:

			/// Constructor
		wgWinEditBox(const char* _pcharButtonID);

			/// Destructor
		~wgWinEditBox();

		HWND Create(const char* Label,				///< The Text Label to be placed on the Button.
					HWND _Parent,					///< The Parent Window.	
					int x,							///< The x (horizontal) position of the Button relative to the window.
					int y,							///< The y (vertical) position of the Button relative to the window.
					int nWidth = CW_USEDEFAULT,		///< The Width of the Button
					int nHeight = CW_USEDEFAULT,	///< The Height of the Button
					UINT Style=WS_CHILD|WS_BORDER|ES_AUTOHSCROLL///< The Style of the Button
				) throw (wuException);


	protected:

			/// Retrieves the size of the text (cstrText) in character width, and vertical lines
		void GetTextDimensions(const char* cstrText, int& _x, int& _y);
};


#endif//_WG_WIN_EDITBOX

