#include "winglib/wgWinMenubar.h"


#ifndef _WG_WIN_MENU
#define _WG_WIN_MENU


///
/// wgWimMenu class is intended to represent the 2nd level Menu component. For instance, the 'File' pull down menu found in 
/// most windows applications is a 2nd level menu component. wgWinMenu can also be used to represent 3+ level components 
/// by not adding any components, and by choosing the appropriate constructor. By not adding any sub menus to a wgWinMenu, it will default to a branch component, 
/// in other words, it will act as a Menu Item, which will trigger an action event when clicked on. One popular example
/// of such a Menu Item is the 'Save' option in the File menu. 
///
class wgWinMenu : public wgWinMenuBar
{
	public:

			/// default constructor
		wgWinMenu();
			/// Create a wgWinMenu object with no Label. This object can be used as a Menu Item. 
		wgWinMenu(unsigned int uintIdentifier);

			/// Create a wgWinMenu object with the specified Label Text. This object should not be used
			/// as a Menu Item since it has no associated Identifier. 
			/// This can be rectified through the use of the wgWinMenuComponent::SetIdentifier(unsigned int uintIdentifier) function.
		wgWinMenu(std::string Text);
		
			/// Create a wgWinMenu object with the specified Label Text, and Identifier. This object can be used as a Menu Item and is the recommended
			/// constructor for such a purpose. 
		wgWinMenu(std::string Text, unsigned int uintIdentifier);

			/// Destructor
		~wgWinMenu();
};


#endif//_WG_WIN_MENU
