#include "winglib/wgWinAbstractButton.h"

#ifndef _WG_WIN_RADIOBUTTON
#define _WG_WIN_RADIOBUTTON

 
///
/// wgWinRadioButton class allows the creation of a child window radio button without the need for a resource file
///
class wgWinRadioButton : public wgWinAbstractButton
{
	public:

			/// Constructor
		wgWinRadioButton(const char* _pcharControlID);

			/// Destructor
		~wgWinRadioButton();

		HWND Create(const char* Label,				///< The Text Label to be placed on the Button.
					HWND _Parent,					///< The Parent Window.
					int x,							///< The x (horizontal) position of the Button relative to the window.
					int y,							///< The y (vertical) position of the Button relative to the window.
					int nWidth = CW_USEDEFAULT,		///< The Width of the Button
					int nHeight = CW_USEDEFAULT,	///< The Height of the Button
					UINT Style=BS_RADIOBUTTON		///< The Style of the Button
				) throw (wuException);




	protected:

			/// Retrieves the size of the text (cstrText) in character width, and vertical lines
		void GetTextDimensions(const char* cstrText, int& _x, int& _y);

};


#endif//_WG_WIN_RADIOBUTTON

