#include "winglib/wgObjectSpecificMutexControl.h"
#include <stdio.h>
#include <string.h>

wgObjectSpecificMutexControl::wgObjectSpecificMutexControl()
{
	// CREATE OBJECT_SPECIFIC_MUTEX
		MutexName = new char[100];
		memset(MutexName, 0, 100);
		sprintf(MutexName, "wgObjectSpecificMutexControlMutex%d", (int)this);
		wgObjectSpecificMutexControlMutex = CreateMutex(NULL, FALSE, MutexName); // mutex is object in scope, through use of unique names
	// END OBJECT_SPECIFIC_MUTEX
}


wgObjectSpecificMutexControl::wgObjectSpecificMutexControl(const wgObjectSpecificMutexControl& other)
{
	int len = strlen(other.MutexName) +1;

	MutexName = new char[len];
	strcpy(MutexName, other.MutexName);
	wgObjectSpecificMutexControlMutex = CreateMutex(NULL, FALSE, MutexName);
}

wgObjectSpecificMutexControl& wgObjectSpecificMutexControl::operator=(const wgObjectSpecificMutexControl& other)
{
	if (&other!=this)
	{
		if (MutexName!=0)
		{
			delete[] MutexName;
		}
		
		if (wgObjectSpecificMutexControlMutex!=0)
		{
			CloseHandle(wgObjectSpecificMutexControlMutex);
		}
		int len = strlen(other.MutexName) +1;

		MutexName = new char[len];
		strcpy(MutexName, other.MutexName);
		wgObjectSpecificMutexControlMutex = CreateMutex(NULL, FALSE, MutexName);
	}

	return *this;
}




wgObjectSpecificMutexControl::~wgObjectSpecificMutexControl()
{

	CloseHandle(wgObjectSpecificMutexControlMutex);
	delete[] MutexName;
}




DWORD wgObjectSpecificMutexControl::WaitForSingleObject(DWORD dwMilliseconds)
{
	return ::WaitForSingleObject(wgObjectSpecificMutexControlMutex, dwMilliseconds);
}




BOOL wgObjectSpecificMutexControl::ReleaseMutex()
{
	return ::ReleaseMutex(wgObjectSpecificMutexControlMutex);
}

