#include "winglib/wgScrollController.h"


wgScrollController::wgScrollController()
{
	wgScrollController::ShWnd = 0;
	wgScrollController::YScrollPos = 0;
	wgScrollController::XScrollPos = 0;
}




wgScrollController::wgScrollController(HWND _ShWnd)
{
	wgScrollController::ShWnd = _ShWnd;
	wgScrollController::YScrollPos = 0;
	wgScrollController::XScrollPos = 0;
}



wgScrollController::~wgScrollController()
{


}


 

void wgScrollController::SetWindow(HWND _ShWnd)
{
	wgScrollController::ShWnd = _ShWnd;
}





bool wgScrollController::ScrollPageY(int ScrollBy)
{
	// first find out a page length
	RECT ParentWindow = GetActualWindowSize();
	return ScrollWindowY(ScrollBy*ParentWindow.bottom);
}



bool wgScrollController::ScrollPageX(int ScrollBy)
{
	// first find out a page length
	RECT ParentWindow = GetActualWindowSize();
	return ScrollWindowX(ScrollBy*ParentWindow.right);
}



bool wgScrollController::ScrollWindowY(int ScrollBy)
{
	RECT vsize = GetVirtualWindowSize();
	RECT ParentWindow = GetActualWindowSize();
	int WindowRoomToMoveY = vsize.bottom - ParentWindow.bottom;
	int intTempYScrollPos = wgScrollController::YScrollPos;
	int intBreachedLimit = 0;

	// if ScrollBy puts the scroll out of legal limits, limit it to the boundaries
	intTempYScrollPos = intTempYScrollPos - ScrollBy;

	if (intTempYScrollPos<0)
	{
		intBreachedLimit = 0;
	}
	else if (intTempYScrollPos>WindowRoomToMoveY)
	{
		intBreachedLimit = WindowRoomToMoveY;
	}
	else // all within limits
	{	
		intBreachedLimit = 0;
		intTempYScrollPos = 0;
	}

	ScrollBy = ScrollBy + (intTempYScrollPos - intBreachedLimit);

	// now set up the scroll
	ScrollWindow(wgScrollController::ShWnd, 0, ScrollBy, NULL, NULL);
	wgScrollController::YScrollPos = wgScrollController::YScrollPos - ScrollBy;
	return (ScrollBy!=0);
}



bool wgScrollController::ScrollWindowX(int ScrollBy)
{
	RECT vsize = GetVirtualWindowSize();
	RECT ParentWindow = GetActualWindowSize();
	int WindowRoomToMoveX = vsize.right - ParentWindow.right;
	int intTempXScrollPos = wgScrollController::XScrollPos;
	int intBreachedLimit = 0;

	// if ScrollBy puts the scroll out of legal limits, limit it to the boundaries
	intTempXScrollPos = intTempXScrollPos - ScrollBy;

	if (intTempXScrollPos<0)
	{
		intBreachedLimit = 0;
	}
	else if (intTempXScrollPos>WindowRoomToMoveX)
	{
		intBreachedLimit = WindowRoomToMoveX;
	}
	else // all within limits
	{	
		intBreachedLimit = 0;
		intTempXScrollPos = 0;
	}

	ScrollBy = ScrollBy + (intTempXScrollPos - intBreachedLimit);

	// now set up the scroll
	ScrollWindow(wgScrollController::ShWnd, ScrollBy, 0, NULL, NULL);
	wgScrollController::XScrollPos = wgScrollController::XScrollPos - ScrollBy;
	return (ScrollBy!=0);
}




void wgScrollController::ResetScroll(int fnBar, int ScrollValue, SCROLLINFO* SInf)
{
	// Initialise local variables
	int WindowRoomToMoveX = 1;
	int WindowRoomToMoveY = 1;
	int ScrollByY = 0;
	int ScrollByX = 0;
	int TempScrollnPosWas = 0;
	int Resolution = 1000;

	SCROLLINFO TempScrollInfo;
	memset((void*)&TempScrollInfo, 0, sizeof(SCROLLINFO));

	if (SInf==NULL)
	{
		SInf = &TempScrollInfo;
	}

	RECT vsize = GetVirtualWindowSize();
	RECT ParentWindow = GetActualWindowSize();

	WindowRoomToMoveX = vsize.right - ParentWindow.right;
	if (WindowRoomToMoveX<0)
	{
		WindowRoomToMoveX = 0;
	}

	WindowRoomToMoveY = vsize.bottom - ParentWindow.bottom;
	if (WindowRoomToMoveY<0) 
	{
		WindowRoomToMoveY = 0;
	}

	// do all common work
	SInf->fMask = SInf->fMask | SIF_PAGE|SIF_RANGE|SIF_POS;
	SInf->cbSize = sizeof(SCROLLINFO);
	SInf->nMin = 1;

	// do actual work based on fnBar

	TempScrollnPosWas = SInf->nPos;

	if (fnBar==SB_VERT || fnBar==SB_BOTH)
	{
		SInf->nMax = Resolution +2; // 1 to make the multiple of 10, and one more to account for the one i take away from it
		SInf->nPage = (unsigned int)(Resolution * ((double)ParentWindow.bottom/(double)vsize.bottom));

		int MaxnPos = SInf->nMax +1  - SInf->nPage;

		if (SInf->nPos==0)
		{	// now because we have the transated out to max already, we must provide a transation back to the proportional type
			int intTrnsltdnPosFrScrllngPge = (int)(((double)wgScrollController::YScrollPos/(double)(WindowRoomToMoveY))* (double)(Resolution));
			SInf->nPos = (int)((double)(MaxnPos*intTrnsltdnPosFrScrllngPge)/(double)SInf->nMax);
		}
		else
		{	// here, because only a percentage of the scrolling is available because of the proportional scrolling, we must translate out to the max
			int intTrnsltdnPosFrScrllngPge = (int) (((double)SInf->nPos / (double)MaxnPos)  * (double)SInf->nMax);
			ScrollByY = (int)((((double)(intTrnsltdnPosFrScrllngPge-1)/(double)(Resolution))  * (double)(abs(WindowRoomToMoveY)) - wgScrollController::YScrollPos));
			wgScrollController::YScrollPos = wgScrollController::YScrollPos + ScrollByY;
		}

		SetScrollInfo(wgScrollController::ShWnd, SB_VERT, SInf, TRUE);
	}


	SInf->nPos = TempScrollnPosWas;	// reset the value to the original before recalculating the vertical


	if (fnBar==SB_HORZ || fnBar==SB_BOTH)
	{
		SInf->nMax = Resolution +2; // 1 to make the multiple of 10, and one more to account for the one i take away from it
		SInf->nPage = (unsigned int)(Resolution * ((double)ParentWindow.right/(double)vsize.right));

		int MaxnPos = SInf->nMax +1  - SInf->nPage;

		if (SInf->nPos==0)
		{	// now because we have the transated out to max already, we must provide a transation back to the proportional type
			int intTrnsltdnPosFrScrllngPge = (int)(((double)wgScrollController::XScrollPos/(double)(WindowRoomToMoveX))* (double)(Resolution));
			SInf->nPos = (int)((double)(MaxnPos*intTrnsltdnPosFrScrllngPge)/(double)SInf->nMax);
		}
		else
		{	// here, because only a percentage of the scrolling is available because of the proportional scrolling, we must translate out to the max
			int intTrnsltdnPosFrScrllngPge = (int) (((double)SInf->nPos / (double)MaxnPos)  * (double)SInf->nMax);
			ScrollByX = (int)((((double)(intTrnsltdnPosFrScrllngPge-1)/(double)(Resolution)) * (double)(abs(WindowRoomToMoveX)) - wgScrollController::XScrollPos)         );
			wgScrollController::XScrollPos = wgScrollController::XScrollPos + ScrollByX;
		}

		SetScrollInfo(wgScrollController::ShWnd, SB_HORZ, SInf, TRUE);
	}


	if (ScrollByY!=0 || ScrollByX!=0)
	{
		ScrollWindow(wgScrollController::ShWnd, -ScrollByX, -ScrollByY, NULL, NULL);
	}
}




unsigned int wgScrollController::GetNumberOfPagesX(const RECT& VirtualWindowSize)
{
	RECT ParentRect = GetActualWindowSize();

	return VirtualWindowSize.right/ParentRect.right + 
			(VirtualWindowSize.right%ParentRect.right!=0)*1;
}




unsigned int wgScrollController::GetNumberOfPagesY(const RECT& VirtualWindowSize)
{
	RECT ParentRect = GetActualWindowSize();

	return VirtualWindowSize.bottom/ParentRect.bottom + 
			(VirtualWindowSize.bottom%ParentRect.bottom!=0)*1;
}




RECT wgScrollController::GetActualWindowSize()
{
	RECT ParentRect;

	GetWindowRect(wgScrollController::ShWnd, &ParentRect);

	ParentRect.bottom = ParentRect.bottom - ParentRect.top;
	ParentRect.top = 0;
	ParentRect.right = ParentRect.right - ParentRect.left;
	ParentRect.left = 0;

	return ParentRect;
}



RECT wgScrollController::GetVirtualWindowSize()
{
	HWND child=0;
	int intCountWindows = 0;
	RECT Rect, LowestRect, ParentRect, VirtualWindowSize;

	GetWindowRect(wgScrollController::ShWnd, &ParentRect);

	LowestRect.bottom = 0;

	while (child = FindWindowEx(wgScrollController::ShWnd, child, NULL, NULL))
	{
		intCountWindows++;
		GetWindowRect(child, &Rect);
		Rect.bottom = (ParentRect.bottom - ParentRect.top) + (Rect.bottom - ParentRect.bottom) + wgScrollController::YScrollPos;
		Rect.right = (ParentRect.right - ParentRect.left) + (Rect.right - ParentRect.right)  +wgScrollController::XScrollPos;
		Rect.left = 0;
		Rect.top = 0;

		if (LowestRect.bottom<Rect.bottom) LowestRect = Rect;
	}

	VirtualWindowSize = GetActualWindowSize();

	if (VirtualWindowSize.bottom<LowestRect.bottom)
	{
		VirtualWindowSize.bottom = LowestRect.bottom + 50;
	}

	if (VirtualWindowSize.right<LowestRect.right)
	{
		VirtualWindowSize.right = LowestRect.right + 50;
	}

	return VirtualWindowSize;
}





