#include "winglib/wgSubclasser.h"


///////////////     START OF wgSubclasser CLASS IMPLEMENTATION         //////////////////


			
wgSubclasser::wgSubclasser(HWND _APPWindowHandle, bool _blnRelinquishOnClose){

	wgWinBase::hWnd = _APPWindowHandle;
	HINSTANCE hinstTemp;

	blnRelinquishOnClose = _blnRelinquishOnClose;

	if (_APPWindowHandle!=0)
		wgWinBase::hInstance = (HINSTANCE)GetWindowLong(_APPWindowHandle, GWL_HINSTANCE);
	else {
		wgWinBase::hInstance = (HINSTANCE)GetModuleHandle(NULL);
		wgWinBase::hWnd = GetTopWindow(NULL);
		while (1)
		{
			hinstTemp = (HINSTANCE)GetWindowLong(wgWinBase::hWnd, GWL_HINSTANCE);
			if (hinstTemp == NULL) break;
			else if (hinstTemp != wgWinBase::hInstance)
				wgWinBase::hWnd = GetNextWindow(wgWinBase::hWnd, GW_HWNDPREV);
			else break;
		}
	}

	OldProc = 0;
}



wgSubclasser::wgSubclasser(bool _blnRelinquishOnClose)
{
	blnRelinquishOnClose = _blnRelinquishOnClose;
	OldProc = 0;
}





wgSubclasser::~wgSubclasser(){

}

const UINT wgSubclasser::CREATE_APP_SUBCLASSING(RegisterWindowMessage("CREATE_EXCEL_SUBCLASSING"));








void wgSubclasser::Associate(HWND _hWnd)
{
	wgWinBase::hWnd = _hWnd;
}





void wgSubclasser::Awgch()	// final --- don't touch
{
			
	if (OldProc==0)	// only do if not done before
	{

		OldProc =(LONG) SetWindowLong(hWnd, GWL_WNDPROC, (LONG) ControlProcedure);
		if (OldProc!=0)
		{
			Awgched = true;
			::SendMessage(hWnd, CREATE_APP_SUBCLASSING, (WPARAM)this, 0);
		}
	}
}


void wgSubclasser::RelinquishControl(){

	if (Awgched) 
	{
		OldProc =SetWindowLong(hWnd, GWL_WNDPROC, (LONG) OldProc);
		Awgched = false;
	}
}



// returns FALSE if NOT handled message
LRESULT CALLBACK wgSubclasser::ControlProcedure(HWND _hWnd, UINT message, WPARAM wParam, LPARAM lParam){

	wgSubclasser* controller = (wgSubclasser*)GetProp(_hWnd, "wgSubclasser");
	LRESULT ReturnResult = 0;

	if (message==CREATE_APP_SUBCLASSING)	// take care of initial setup
	{
		if (controller==NULL)
		{
			SetProp(_hWnd, "wgSubclasser", (HANDLE)wParam);
			controller = (wgSubclasser*)wParam;
			controller->_OnUser();
		}
		else controller->OnOther(message, wParam, lParam);	// if not initial setup, pass along to user function

		return 0;
	}
	

	switch(message)		// take care of any windows messages we want to manage
	{
		case WM_CLOSE:
			if (controller!=0)
			{
				controller->OnOther(message, wParam, lParam);

				if (controller->blnRelinquishOnClose)
				{
					controller->RelinquishControl();
					::PostMessage(_hWnd, WM_CLOSE, 0,0);
					return 0;
				}
			}

		default: if (controller!=0) controller->OnOther(message, wParam, lParam);
	};

	if (controller!=0)	// now call the original windows handler function so all other things can happen normally
	{
		ReturnResult = CallWindowProc((WNDPROC)(controller->OldProc), _hWnd, message, wParam, lParam);
		if (controller!=0) controller->OnWindowMessageReturn(message, ReturnResult);
		return ReturnResult;
	}	
	else return 0;	// return zero in a window message process function usually means 'processed message'
}



void wgSubclasser::_OnUser(){

	RECT rect;
	POINT p;

	GetWindowRect(hWnd, &rect);
	p.x = rect.left;
	p.y = rect.top;
	ScreenToClient(hWnd, &p);

	if (SWin_Width==0) SWin_Width = rect.right-rect.left;	// if zero set default
	if (SWin_Height==0) SWin_Height = rect.bottom-rect.top;	// if zero set default
	
	SetWindowPos(hWnd, HWND_TOP, p.x, p.y, SWin_Width, SWin_Height, SWP_NOZORDER|SWP_NOMOVE);
	OnInit();	// call empty function OR child overridden function
}



////////////////////// START OF wgSubclasser Implementation //////////////////

