#include "winglib/wgWinAbstractButton.h"
#include <string.h>


wgWinAbstractButton::wgWinAbstractButton(const char* _pcharButtonID) :	wgWinControl(_pcharButtonID), 
																			wgWindow(NULL, "BUTTON", NULL)
{
}




wgWinAbstractButton::~wgWinAbstractButton()
{

}





HWND wgWinAbstractButton::Create(const char* Label, HWND _Parent, int x, int y, int nWidth, int nHeight, UINT Style) throw (wuException)
{
	HWND Return = NULL;

	Return = wgWindow::Create((char*)Label, WS_CHILDWINDOW|Style, x, y, nWidth, nHeight ,NULL, NULL, _Parent);

	Attach(); 

	return Return;
}




 

LRESULT wgWinAbstractButton::OnOther(UINT message, WPARAM wParam, LPARAM lParam)
{
	LRESULT lrRes = 1;

	AbsMutex.WaitForSingleObject(0);

	lrRes = GetListener().OnOtherAction(message, wParam, lParam, this);

	AbsMutex.ReleaseMutex();

	return lrRes;
}


LRESULT wgWinAbstractButton::OnMouseMove(WPARAM wParam, LPARAM lParam)
{
	LRESULT lrRes = 1;

	AbsMutex.WaitForSingleObject(0);

	lrRes = GetListener().OnMouseMoveAction(wParam, lParam, this);

	AbsMutex.ReleaseMutex();

	return lrRes;
}



LRESULT wgWinAbstractButton::OnMouseLButtonDown(WPARAM wParam, LPARAM lParam)
{
	LRESULT lrRes = 1;

	AbsMutex.WaitForSingleObject(0);

	lrRes = GetListener().OnMouseLButtonDownAction(wParam, lParam, this);

	AbsMutex.ReleaseMutex();

	return lrRes;
}



LRESULT wgWinAbstractButton::OnMouseLButtonUp(WPARAM wParam, LPARAM lParam)
{	
	LRESULT lrRes = 1;

	AbsMutex.WaitForSingleObject(0);

	lrRes = GetListener().OnMouseLButtonUpAction(wParam, lParam, this);

	AbsMutex.ReleaseMutex();

	return lrRes;
}



LRESULT wgWinAbstractButton::OnMouseRButtonDown(WPARAM wParam, LPARAM lParam)
{
	LRESULT lrRes = 1;

	AbsMutex.WaitForSingleObject(0);

	lrRes = GetListener().OnMouseRButtonDownAction(wParam, lParam, this);

	AbsMutex.ReleaseMutex();

	return lrRes;
}



LRESULT wgWinAbstractButton::OnMouseRButtonUp(WPARAM wParam, LPARAM lParam)
{
	LRESULT lrRes = 1;

	AbsMutex.WaitForSingleObject(0);

	lrRes = GetListener().OnMouseRButtonUpAction(wParam, lParam, this);

	AbsMutex.ReleaseMutex();

	return lrRes;
}


	// sent to window loosing
	// capture. It recieves HWND of window
	// gaining the mouse capture
LRESULT wgWinAbstractButton::OnCaptureChanged(HWND hwndNewCapture)
{
	LRESULT lrRes = 1;

	AbsMutex.WaitForSingleObject(0);

	lrRes = GetListener().OnCaptureChangedAction(hwndNewCapture, this);

	AbsMutex.ReleaseMutex();

	return lrRes;
}


LRESULT wgWinAbstractButton::OnNCDestroy()
{
	LRESULT lrRes = 1;

	AbsMutex.WaitForSingleObject(0);

	UnAttach();

	IsChecked();

	lrRes = GetListener().OnNCDestroyAction(this);

	AbsMutex.ReleaseMutex();

	return lrRes;
}



LRESULT wgWinAbstractButton::OnDestroy()
{
	LRESULT lrRes = 1;

	AbsMutex.WaitForSingleObject(0);

	lrRes = GetListener().OnDestroyAction(this);

	AbsMutex.ReleaseMutex();

	return lrRes;
}



LRESULT wgWinAbstractButton::OnPaint()
{
	LRESULT lrRes = 1;

	AbsMutex.WaitForSingleObject(0);

	lrRes = GetListener().OnPaintAction(this);

	AbsMutex.ReleaseMutex();

	return lrRes;
}






char wgWinAbstractButton::IsChecked()
{
	if (IsCreated())
	{
		CheckedState = SendMessage(BM_GETSTATE, 0, 0);
	}

	return CheckedState;
}


void wgWinAbstractButton::SetState(int blnChecked)
{
	if (IsCreated())
	{
		SendMessage(BM_SETCHECK, blnChecked, 0); 
	}
}

