#include "winglib/wgWinAbstractStaticComponent.h"
#include <string.h>


wgWinAbstractStaticComponent::wgWinAbstractStaticComponent(const char* _pcharButtonID) :	wgWinControl(_pcharButtonID), 
																			wgWindow(NULL, "STATIC", NULL)
{
}




wgWinAbstractStaticComponent::~wgWinAbstractStaticComponent()
{

}





HWND wgWinAbstractStaticComponent::Create(const char* Label, HWND _Parent, int x, int y, int nWidth, int nHeight, UINT Style) throw (wuException)
{
	HWND Return = NULL;

	Return = wgWindow::Create((char*)Label, WS_CHILDWINDOW|Style, x, y, nWidth, nHeight, NULL, NULL, _Parent);

	Attach(); 

	return Return;
}






LRESULT wgWinAbstractStaticComponent::OnOther(UINT message, WPARAM wParam, LPARAM lParam)
{
	LRESULT lrRes = 1;

	AbsMutex.WaitForSingleObject(0);

	try
	{
		lrRes = GetListener().OnOtherAction(message, wParam, lParam, this);
	}
	catch(...)
	{
	}

	AbsMutex.ReleaseMutex();

	return lrRes;
}


LRESULT wgWinAbstractStaticComponent::OnMouseMove(WPARAM wParam, LPARAM lParam)
{
	LRESULT lrRes = 1;

	AbsMutex.WaitForSingleObject(0);

	try
	{	
		lrRes = GetListener().OnMouseMoveAction(wParam, lParam, this);
	}
	catch(...)
	{
	}

	AbsMutex.ReleaseMutex();

	return lrRes;
}



LRESULT wgWinAbstractStaticComponent::OnMouseLButtonDown(WPARAM wParam, LPARAM lParam)
{
	LRESULT lrRes = 1;

	AbsMutex.WaitForSingleObject(0);

	try
	{
		lrRes = GetListener().OnMouseLButtonDownAction(wParam, lParam, this);
	}
	catch(...)
	{
	}

	AbsMutex.ReleaseMutex();

	return lrRes;
}



LRESULT wgWinAbstractStaticComponent::OnMouseLButtonUp(WPARAM wParam, LPARAM lParam)
{	
	LRESULT lrRes = 1;

	AbsMutex.WaitForSingleObject(0);

	try
	{
		lrRes = GetListener().OnMouseLButtonUpAction(wParam, lParam, this);
	}
	catch(...)
	{
	}

	AbsMutex.ReleaseMutex();

	return lrRes;
}



LRESULT wgWinAbstractStaticComponent::OnMouseRButtonDown(WPARAM wParam, LPARAM lParam)
{
	LRESULT lrRes = 1;

	AbsMutex.WaitForSingleObject(0);

	try
	{
		lrRes = GetListener().OnMouseRButtonDownAction(wParam, lParam, this);
	}
	catch(...)
	{
	}

	AbsMutex.ReleaseMutex();

	return lrRes;
}



LRESULT wgWinAbstractStaticComponent::OnMouseRButtonUp(WPARAM wParam, LPARAM lParam)
{
	LRESULT lrRes = 1;

	AbsMutex.WaitForSingleObject(0);

	try
	{
		lrRes = GetListener().OnMouseRButtonUpAction(wParam, lParam, this);
	}
	catch(...)
	{
	}

	AbsMutex.ReleaseMutex();

	return lrRes;
}


	// sent to window loosing
	// capture. It recieves HWND of window
	// gaining the mouse capture
LRESULT wgWinAbstractStaticComponent::OnCaptureChanged(HWND hwndNewCapture)
{
	LRESULT lrRes = 1;

	AbsMutex.WaitForSingleObject(0);

	try
	{
		lrRes = GetListener().OnCaptureChangedAction(hwndNewCapture, this);
	}
	catch(...)
	{
	}

	AbsMutex.ReleaseMutex();

	return lrRes;
}





LRESULT wgWinAbstractStaticComponent::OnNCDestroy()
{
	LRESULT lrRes = 1;

	AbsMutex.WaitForSingleObject(0);

	UnAttach();

	try
	{
		lrRes = GetListener().OnNCDestroyAction(this);
	}
	catch(...)
	{
	}

	AbsMutex.ReleaseMutex();

	return lrRes;
}



LRESULT wgWinAbstractStaticComponent::OnDestroy()
{
	LRESULT lrRes = 1;

	AbsMutex.WaitForSingleObject(0);

	try
	{
		lrRes = GetListener().OnDestroyAction(this);
	}
	catch(...)
	{
	}

	AbsMutex.ReleaseMutex();

	return lrRes;
}



LRESULT wgWinAbstractStaticComponent::OnPaint()
{
	LRESULT lrRes = 1;

	AbsMutex.WaitForSingleObject(0);

	try
	{
		lrRes = GetListener().OnPaintAction(this);
	}
	catch(...)
	{
	}

	AbsMutex.ReleaseMutex();

	return lrRes;
}


