#include "winglib/wgWinDialogWindow.h"

 //CBS_AUTOHSCROLL|WS_VSCROLL
wgWinDialogWindow::wgWinDialogWindow(	HINSTANCE _hInstance, 
										LPCTSTR ClassName, 
										UINT style,
										int Menu, 
										HICON LargeIcon, 
										HICON SmallIcon, 
										HBRUSH brush, 
										HCURSOR cursor, 
										int ClassExtra
									) throw (wuException)
							:wgWindow(_hInstance, true)//true=dialog
{
//#32770
	WNDCLASSEX wcx;  
	BOOL Res = GetClassInfoEx(_hInstance, "#32770", &wcx);
	ATOM atom;	

	if (Res)	// tailor this class to users needs, change the name, and reregister
	{
		wcx.lpszClassName = ClassName;
		wcx.cbWndExtra = DLGWINDOWEXTRA;
		wcx.lpfnWndProc = (WNDPROC)wgWindow::GetWindowMessageHandler();
		wcx.hInstance = _hInstance;
		wcx.cbSize = sizeof(WNDCLASSEX);

		if (style!=NULL) wcx.style = style;
		if (Menu!=NULL && Menu !=NO_MENU)  wcx.lpszMenuName = MAKEINTRESOURCE(Menu);
		if (LargeIcon!=NULL) wcx.hIcon = LargeIcon;
		if (SmallIcon!=NULL) wcx.hIconSm = SmallIcon;
		if (brush!=NULL) wcx.hbrBackground = brush;
		if (cursor!=NULL) wcx.hCursor = cursor;
		if (ClassExtra!=NULL) wcx.cbClsExtra = ClassExtra;
	}
	else
	{
		throw wuException("Class unknown error");
	}

	try
	{
		wgWindow::winmaker = new wgWinMaker(wcx);
	}
	catch(...)
	{
		throw wuException("memory allocation error");
	}

	atom = wgWindow::winmaker->register_class();
	DWORD err = GetLastError();
	
	if (err!=ERROR_CLASS_ALREADY_EXISTS && atom==0)
	{
		throw wuException("class register error, see ::GetLastError");
	}
}



