
#include "winglib/wgWinMakerBase.h"
#include <winutils/wuRegistry.h>
#include <string>
#include <stdio.h>

////////// implementation of wgWinMakerBase



wgWinMakerBase::wgWinMakerBase(){

	wgWinRegKeyInitMutex = CreateMutex(NULL, FALSE, "wgWinRegKeyInitMutex"); // make multithread safe

	windows_created_by_this=0;
//	hkeyPID=0;
	register_wgWinMaker();
}


wgWinMakerBase::~wgWinMakerBase(){

//	unregister_wgWinMaker();

	CloseHandle(wgWinRegKeyInitMutex);
}




int wgWinMakerBase::key_init(1); // 1 is initial value that it starts off with, 
							// later if in constructor found at more than 1 that means
							// that that isn't the first instance created






// purpose of registration
/*

create the WinSute subkey of Software, then it's WinMaker underneath that. 
stores the WinMaker key

*/

// this registers the WinSute class, and the wgWinMaker class
void wgWinMakerBase::register_wgWinMaker(){

	HKEY hKey;
	DWORD wh;

	LONG Result = RegCreateKeyPath("HKEY_CURRENT_USER\\Software\\WinSute\\wgWinMaker", NULL,
						REG_OPTION_VOLATILE, KEY_ALL_ACCESS, NULL,&hKey,
						&wh);

	if (Result != ERROR_SUCCESS){
	
		MessageBox(NULL, "Registration Failure", "Warning", MB_OK);
	}
	else RegCloseKey(hKey);
}




void wgWinMakerBase::update_registry(HWND _hWnd){

	WaitForSingleObject(wgWinRegKeyInitMutex, 30000); // ask for ownership

	HKEY hkeyOWI;
	HKEY hkeyPID;
	DWORD wh;
	char ckey[1024]={0};
	LONG Result = 0;

	if (_hWnd!=0){
	
		char hWndString[34]={0}; // store a string representation of hWnd value
		int hWndSize = 0;

		GetWindowThreadProcessId(_hWnd, &PID); // RETRIEVES THE PID FROM THE SYSTEM 
	
		sprintf(ckey, "HKEY_CURRENT_USER\\Software\\WinSute\\wgWinMaker\\app=%d", (long)PID);

		Result = RegCreateKeyPath(ckey, NULL,
						REG_OPTION_VOLATILE, KEY_ALL_ACCESS, NULL,&hkeyPID,
						&wh);

		sprintf(hWndString, "%d", _hWnd);
		hWndSize = strlen(hWndString) +1; // + 1 to include the null 

		windows_created_by_this++; // new addition to common function

		// create OpenWindowInfo key 
		if  (Result==ERROR_SUCCESS){ //--->
		
			// open OpenWindowInfo key
			Result = RegCreateKeyEx(hkeyPID, "OpenWindowInfo", 0, "OpenWindowInfo", 
							REG_OPTION_VOLATILE, KEY_QUERY_VALUE | KEY_SET_VALUE, NULL,
							&hkeyOWI, &wh);

			if (Result == ERROR_SUCCESS){ //--->

				if (key_init==1 || wh==REG_CREATED_NEW_KEY){// at this point, this is first instance of wgWinMaker in this app

					// set OpenWindowInfo to 1
					DWORD val=1;
					RegSetValueEx(hkeyOWI, "WMWindowCount", 0, REG_DWORD, (CONST BYTE*)&val, sizeof(DWORD));  
				}
				else 
				{
					// increment
					DWORD val=0, dataType, size = sizeof(DWORD);

					LONG Res = RegQueryValueEx(hkeyOWI, "WMWindowCount", 0, &dataType,(LPBYTE) &val, &size);
	
					if (Res == ERROR_SUCCESS)
					{
						val= val +1;
						Res = RegSetValueEx(hkeyOWI, "WMWindowCount", 0, REG_DWORD, (CONST BYTE*)&val, sizeof(DWORD)); 
					}
					else
					{
						
					}
				}

				// now set the value of the current hWnd in the registry
				RegSetValueEx(hkeyOWI, hWndString, 0, REG_SZ, (CONST BYTE*)hWndString, hWndSize); 
				RegCloseKey(hkeyOWI);
				RegCloseKey(hkeyPID);
			} 
		}
		else ::MessageBox(NULL, "windows registry init failure", "WARNING", MB_OK);

		key_init++;
	
	} // end if if hWnd

	ReleaseMutex(wgWinRegKeyInitMutex); // give up mutex here (release ownership)
}


 #include <WINERROR.H>



// purpose of registration
void wgWinMakerBase::unregister_wgWinMaker(){

	WaitForSingleObject(wgWinRegKeyInitMutex, 30000); // ask for ownership

	HKEY hkeyOWI;
	HKEY hkeyPID;
	HKEY hkeyWinMaker;
	DWORD wh, val, dataType, size;
	char ckey[1024]={0};
	LONG Result = 0;

	sprintf(ckey, "app=%d", (long)PID);

	Result = RegCreateKeyPath("HKEY_CURRENT_USER\\Software\\WinSute\\wgWinMaker" , NULL,
								REG_OPTION_VOLATILE, KEY_ALL_ACCESS, NULL,&hkeyWinMaker, &wh);

	if (Result == ERROR_SUCCESS){

		Result = RegCreateKeyEx(hkeyWinMaker, ckey, 0, ckey, 
					REG_OPTION_VOLATILE, KEY_QUERY_VALUE | KEY_SET_VALUE, NULL,
					&hkeyPID, &wh);

		if (Result == ERROR_SUCCESS){

			Result = RegCreateKeyEx(hkeyPID, "OpenWindowInfo", 0, "OpenWindowInfo", 
						REG_OPTION_VOLATILE, KEY_QUERY_VALUE | KEY_SET_VALUE, NULL,
						&hkeyOWI, &wh);

			if (Result == ERROR_SUCCESS){

				size = sizeof(DWORD);				
				RegQueryValueEx(hkeyOWI, "WMWindowCount", 0, &dataType,(LPBYTE) &val, &size);
				if (val>0) val= val - windows_created_by_this; // windows_created_by_this, means number of windows created by thsi winmaker which we are unregistering
				if (val<0) val=0;
				key_init = key_init - windows_created_by_this;
				if (key_init<1) key_init = 1;
				RegSetValueEx(hkeyOWI, "WMWindowCount", 0, REG_DWORD, (CONST BYTE*)&val, sizeof(DWORD));
			
				RegCloseKey(hkeyOWI);

				if (val<1){

					RegDeleteKey(hkeyPID, "OpenWindowInfo");
					RegCloseKey(hkeyPID);
					RegDeleteKey(hkeyWinMaker, ckey);
					RegCloseKey(hkeyWinMaker);

				}
			}
		}
	}

	ReleaseMutex(wgWinRegKeyInitMutex); // give up mutex here (release ownership)
}





// purpose of registration
void wgWinMakerBase::unregister_window(HWND _hWnd){

	WaitForSingleObject(wgWinRegKeyInitMutex, 30000); // ask for ownership

	HKEY hkeyOWI;
	DWORD wh, val=0, dataType, size;
	char hWndString[34]={0}; // store a string representation of hWnd value
	char dest[1024]={0};
	int hWndSize = 0;
	char ckey[1024]={0};
	LONG Result = 0;

	GetWindowThreadProcessId(_hWnd, &PID); // RETRIEVES THE PID FROM THE SYSTEM 

	sprintf(ckey, "HKEY_CURRENT_USER\\Software\\WinSute\\wgWinMaker\\app=%d\\OpenWindowInfo", (long)PID);

	Result = RegCreateKeyPath(ckey, NULL,
						REG_OPTION_VOLATILE, KEY_ALL_ACCESS, NULL,&hkeyOWI, &wh);

	if (Result==ERROR_SUCCESS){
		// get string for _hWnd
		sprintf(hWndString, "%d", _hWnd);
		hWndSize = strlen(hWndString) +1; // + 1 to include the null 
		// find an entry for the window in the registry
		size = sizeof(dest);	// size of allocation for dest
		Result = RegQueryValueEx(hkeyOWI, hWndString, 0, &dataType,(LPBYTE) dest, &size);

		if (Result==ERROR_SUCCESS){ // if it exists, unregister

			size = sizeof(DWORD);
			RegQueryValueEx(hkeyOWI, "WMWindowCount", 0, &dataType,(LPBYTE) &val, &size);
			if (val>0) val= val -1;
			if (key_init>1) key_init = key_init -1;
			if (windows_created_by_this>0) windows_created_by_this--;
			RegSetValueEx(hkeyOWI, "WMWindowCount", 0, REG_DWORD, (CONST BYTE*)&val, sizeof(DWORD)); 
			RegDeleteValue(hkeyOWI, hWndString);
		}

		RegCloseKey(hkeyOWI);
		// else do nothing this once, no error matters, because we expect user to
		// call this maybe two places, and the if takes care of the case where
		// it has already been unregistered, or wasn't every registered
	}

	ReleaseMutex(wgWinRegKeyInitMutex); // give up mutex here (release ownership)
}




unsigned int wgWinMakerBase::GetNumOpenWindows(){

	HKEY hkeyOWI;
	DWORD wh, val=0, dataType, size;
	char ckey[1024]={0};
	LONG Result = 0;

	sprintf(ckey, "HKEY_CURRENT_USER\\Software\\WinSute\\wgWinMaker\\app=%d\\OpenWindowInfo", (long)PID);

	Result = RegCreateKeyPath(ckey, NULL,
						REG_OPTION_VOLATILE, KEY_ALL_ACCESS, NULL,&hkeyOWI, &wh);

	if (Result == ERROR_SUCCESS){
		
		size = sizeof(DWORD);
		RegQueryValueEx(hkeyOWI, "WMWindowCount", 0, &dataType,(LPBYTE) &val, &size);
		RegCloseKey(hkeyOWI);
	}

	return (unsigned int)val;

}



///////////// end of wgWinMakerBase implementation
