#include "winglib/wgWinMenuComponent.h"
#include <string.h>


using namespace std;




wgWinMenuComponent::wgWinMenuComponent()
{
	memset((void*)&MenuItemInfo, 0, sizeof(MENUITEMINFO));
}

 


wgWinMenuComponent::wgWinMenuComponent(unsigned int uintIdentifier)
{
	memset((void*)&MenuItemInfo, 0, sizeof(MENUITEMINFO));
	SetIdentifier(uintIdentifier);
}





wgWinMenuComponent::wgWinMenuComponent(string strText)
{

	memset((void*)&MenuItemInfo, 0, sizeof(MENUITEMINFO));

	SetText(strText);

	MenuItemInfo.fMask = MIIM_TYPE | MIIM_STATE |MIIM_SUBMENU |MIIM_ID | MIIM_DATA;
	MenuItemInfo.cbSize = sizeof(MENUITEMINFO);
}





wgWinMenuComponent::wgWinMenuComponent(string strText, unsigned int uintIdentifier)
{

	memset((void*)&MenuItemInfo, 0, sizeof(MENUITEMINFO));

	SetText(strText);
	SetIdentifier(uintIdentifier);	

	MenuItemInfo.fMask = MIIM_TYPE | MIIM_STATE |MIIM_SUBMENU |MIIM_ID | MIIM_DATA;
	MenuItemInfo.cbSize = sizeof(MENUITEMINFO);
}





wgWinMenuComponent::~wgWinMenuComponent()
{
	if (MenuItemInfo.dwTypeData!=0) delete[] MenuItemInfo.dwTypeData;
}






void wgWinMenuComponent::SetText(std::string strText)
{
	if (MenuItemInfo.dwTypeData!=0) delete[] MenuItemInfo.dwTypeData;

	int templen = strlen(strText.c_str()) + 1;

	MenuItemInfo.dwTypeData = new char[templen];

	strcpy(MenuItemInfo.dwTypeData, strText.c_str());
	MenuItemInfo.cch = strlen(MenuItemInfo.dwTypeData);
	MenuItemInfo.cbSize = sizeof(MENUITEMINFO);
}




void wgWinMenuComponent::SetIdentifier(unsigned int uintIdentifier)
{
	MenuItemInfo.wID = uintIdentifier;
}




void wgWinMenuComponent::SetItemData(DWORD dwItemData)
{
	MenuItemInfo.dwItemData = dwItemData;
}