#include "winglib/wgWinRadioButton.h"
#include <winutils/wuStokenizer.h>
#ifndef STRICT
	#define STRICT
#endif
#ifndef _WIN32_WINNT 
	#define _WIN32_WINNT 0x0400
#endif//_WIN32_WINNT
// fix for mfc
#if defined(WIN32)
	#ifdef _AFXDLL
		#include <afx.h>
	#else
		#include<windows.h>
	#endif
#endif	



wgWinRadioButton::wgWinRadioButton(const char* _pcharControlID) :	wgWinAbstractButton(_pcharControlID)
{
}



wgWinRadioButton::~wgWinRadioButton()
{
}




HWND wgWinRadioButton::Create(const char* Label, HWND _Parent, int x, int y, int nWidth, int nHeight, UINT Style) throw (wuException)
{
	HWND Return = NULL;
	int FWidth=0, FHeight=0;

	if (nWidth == CW_USEDEFAULT || nHeight == CW_USEDEFAULT)
	{
		GetTextDimensions(Label, FWidth, FHeight);

		FWidth = (int)(((float)(FWidth<1)*10 + (FWidth>=1)*FWidth) *5.6) +28;
		FHeight = ((FHeight<1)*1 + (FHeight>=1)*FHeight)*15 +0;

		if (nWidth == CW_USEDEFAULT) nWidth = FWidth;
		if (nHeight == CW_USEDEFAULT) nHeight = FHeight;
	}

	Return = wgWinAbstractButton::Create((char*)Label, _Parent, x, y, nWidth, nHeight, Style|BS_RADIOBUTTON);

	return Return;
} 



 
void wgWinRadioButton::GetTextDimensions(const char* cstrText, int& _x, int& _y)
{

	wuStokenizer tok(cstrText, "\r\n");
	std::string temp="";
	_x=0;	// set to min
	_y=0;	// set to min

	while(tok.more()){
		
		temp = tok.next();
		_y++;
		if ((int)temp.size()>_x) _x = temp.size();
	}
}



