

#include "winglib/wgWinTrayIcon.h"

wgWinTrayIcon::wgWinTrayIcon(void)
{
	Data.cbSize=0;
	Data.hWnd=0;
	Data.uID=0;
	Data.uFlags=0;
	Data.uCallbackMessage=0;
	Data.hIcon=0;
	Data.szTip[0]='\0';
	uTrayed=0;
}

wgWinTrayIcon::wgWinTrayIcon(const HWND hwnd, const UINT uMsg, const UINT uID, 
                     const HICON hIcon, const char* pTip)
{
	Data.cbSize=sizeof(NOTIFYICONDATA);
	Data.hWnd=hwnd;   //notification messages are sent to window hwnd
	Data.uID=uID;     //identifier of the taskbar icon
	Data.uCallbackMessage=uMsg; //notification message sent when mouse event occurs
	Data.hIcon=hIcon; //icon handle

	if(pTip)          //if tooltip is specified
	{
		strcpy(Data.szTip, pTip);
		Data.uFlags=NIF_ICON | NIF_MESSAGE | NIF_TIP;
	}
	else
	{
		Data.uFlags=NIF_ICON | NIF_MESSAGE;
	}

	uTrayed=0;
}

wgWinTrayIcon::~wgWinTrayIcon(void)
{
	if(uTrayed)
	{
		Shell_NotifyIcon(NIM_DELETE, &Data);
		uTrayed=0;
	}
}


void wgWinTrayIcon::Init(const HWND hwnd, const UINT uMsg, const UINT uID, 
                     const HICON hIcon, const char* pTip)
{
	Data.cbSize=sizeof(NOTIFYICONDATA);
	Data.hWnd=hwnd;
	Data.uID=uID;
	Data.uCallbackMessage=uMsg;
	Data.hIcon=hIcon;

	if(pTip)
	{
		strcpy(Data.szTip, pTip);
		Data.uFlags=NIF_ICON | NIF_MESSAGE | NIF_TIP;
	}
	else
	{
		Data.uFlags=NIF_ICON | NIF_MESSAGE;
	}
}

void wgWinTrayIcon::AddToTray(void)
{
	if(!uTrayed)
	{
		Shell_NotifyIcon(NIM_ADD, &Data);
		uTrayed=1;
	}
}

void wgWinTrayIcon::RemoveFromTray(void)
{
	if(uTrayed)
	{
		Shell_NotifyIcon(NIM_DELETE, &Data);
		uTrayed=0;
	}
}

void wgWinTrayIcon::Modify(const HICON hIcon)
{
	if(uTrayed)
	{
		Data.hIcon=hIcon;
		Shell_NotifyIcon(NIM_MODIFY, &Data);
	}
}

void wgWinTrayIcon::Modify(const char* pTip)
{
	if(uTrayed)
	{
		if(pTip)
		{
			if(!Data.szTip[0])  //if previously no tooltip
			{
				Data.uFlags=Data.uFlags | NIF_TIP;
			}

			strcpy(Data.szTip, pTip);
		}
		else
		{
			Data.uFlags=NIF_ICON | NIF_MESSAGE;
		}

		Shell_NotifyIcon(NIM_MODIFY, &Data);
	}
}