
#include "winutils/wuException.h"





#ifndef _WU_ARRAY_EXCEPTION
#define _WU_ARRAY_EXCEPTION




///
/// wuArrayException inherits from wuException. It is thrown by wuSafeArray for various 
/// reasons, such as invalid index error. See SafeArray and associated functions for error codes
///
class wuArrayException : public wuException
{

	public:	

			/// Main constructor
		wuArrayException(	const char* amessage,	///<  Exception Description
						long _hResult		///<  Exception Code
					) throw(): wuException(amessage){hResult = _hResult;}
			/// Copy constructor
		wuArrayException(const wuArrayException& other) throw() : wuException(other){hResult = other.hResult;}
			/// assignment operator=
		wuArrayException& operator=(const wuArrayException& other) throw(); 

		virtual const long WhatResult() const throw();

	protected:

		long hResult;
};




#endif//_WU_ARRAY_EXCEPTION