#ifndef wuFile_H
#define wuFile_H


//--------------------------------------------------------------


// SYSTEM INCLUDES
//
#ifndef _WINSOCKAPI_
	#define _WINSOCKAPI_
#endif//_WINSOCKAPI_

#ifndef STRICT
	#define STRICT
#endif
#ifndef _WIN32_WINNT 
	#define _WIN32_WINNT 0x0400
#endif//_WIN32_WINNT

// fix test for mfc
#if defined(WIN32)
	#ifdef _AFXDLL
		#include <afx.h>
	#else
		#include<windows.h>
	#endif
#endif

#include <string>


DWORD GetHandleFilePath(HMODULE hModule, LPTSTR lpFilename,  DWORD nSize);

// PROJECT INCLUDES
//


// LOCAL INCLUDES
//


// FORWARD REFERENCES
//


//--------------------------------------------------------------

///
/// wuFile class provides file manipulation functionality.
///
class wuFile
{


	public:

			/// Default constructor
		wuFile(void);

			/// Constructor
		wuFile(std::string		strFilePath,
				std::string		strFileName,
				unsigned int	intTimeout, 
				bool			blnExistingFile,
				bool			blnReadOnly);

			/// Destructor
		virtual ~wuFile(void);

			/// Initialise file
		bool Initialise(	std::string			strFilePath,
							std::string			strFileName,
							unsigned int	intTimeout, 
							bool			blnExistingFile,
							bool			blnReadOnly);

			/// Set settings
		void SetSettings(	std::string			strFilePath,
							std::string			strFileName,
							unsigned int	intTimeout, 
							bool			blnExistingFile,
							bool			blnReadOnly);

			/// Set file path
		void SetFilePath(std::string strFilePath) { mstrFilePath = strFilePath; }

			/// Get file path
		std::string GetFilePath(void);

			/// Set file name
		void SetFileName(std::string strFileName) { mstrFileName = strFileName; }

			/// Get file name
		std::string GetFileName(void) { return(mstrFileName); }

			/// Get file path and name
		std::string GetFilePathName(void) { return(mstrFilePath + "\\" + mstrFileName); }

			/// Valid Settings?
		bool ValidSettings(void);

			/// Wait for mutex
		DWORD WaitForFileMutex(void);

			/// Release mutex
		bool ReleaseFileMutex(void);
		
			/// Open file
		virtual bool Open(void);

			/// Close file
		void Close(void);

			/// Write message
		bool WriteLine(const char* cpcharMsg);

		bool Write(const char* cpcharMsg);

			/// Flush file
		void Flush(void);

			/// Return the size of the file in bytes
		unsigned long GetFileSize(void);


	protected:

	private:

		HANDLE			mobjFile;			///< file object
		HANDLE			mhdlMutex;			///< file mutex
		std::string		mstrFilePath;		///< file path
		std::string		mstrFileName;		///< file name

		unsigned int	mintTimeout;		///< mutex timeout (milliseconds)

		bool			mblnFileExist;		///< does file already exist
		bool			mblnReadOnly;		///< open file for reading
		
};


//--------------------------------------------------------------


#endif //wuFile