//#include <wuWinStatic.h>
#include "winutils/wuFile.h"

#ifndef _WU_GLOBAL_MEMORY_CLASS
#define _WU_GLOBAL_MEMORY_CLASS

///
/// GlobalMemory is a class that allows the easy usage of System-Global data.
///
class GlobalMemory{

	public:

		GlobalMemory():	dwMemoryFileSize(1024),
							sMemoryFileName("GLOBAL_MEMORY_DEFAULT_FILE_NAME"){}

		GlobalMemory(const char* MemoryFileName, unsigned int MemoryFileSize) 
						:	dwMemoryFileSize(MemoryFileSize),
							sMemoryFileName(MemoryFileName){

		}

		GlobalMemory(const GlobalMemory& other)					
						:	dwMemoryFileSize(other.dwMemoryFileSize),
							sMemoryFileName(other.sMemoryFileName){
			
			m_hFileMapping = other.m_hFileMapping;
			m_pViewOfFile = other.m_pViewOfFile;

		}

		GlobalMemory& operator=(const GlobalMemory& other){
		
			if (&other!=this){

				m_hFileMapping = other.m_hFileMapping;
				m_pViewOfFile = other.m_pViewOfFile;
				dwMemoryFileSize = other.dwMemoryFileSize;
				sMemoryFileName = other.sMemoryFileName;
			}

			return *this;
		} 

		~GlobalMemory(){

			CleanupSystemGlobalData();
		}


		void SetupSystemGlobalData() throw();
		void CleanupSystemGlobalData();
		void GetGlobalData(char* GlobalMemory, unsigned int maxlen);
		void PutGlobalData(const char* PutGlobalMemory, unsigned int len);
		void GetGlobalDataAsString(char* GlobalMemory, unsigned int maxlen);
		void PutGlobalDataAsString(const char* PutGlobalMemory, unsigned int len);

	private:


		HANDLE m_hFileMapping;
		LPVOID m_pViewOfFile ;

		DWORD dwMemoryFileSize;	// number of characters in memory-mapped file
		LPCTSTR sMemoryFileName;	// memory-mapped file name

};



#endif //_WU_GLOBAL_MEMORY_CLASS