
#include "winutils/wuException.h"



#ifndef _WU_OLE_EXCEPTION
#define _WU_OLE_EXCEPTION





///
/// wuOleException class is the base exception class for all Ole operations. It inherits from wuException class.
///

class wuOleException : public wuException
{

	public:	

			/// Main constructor
		wuOleException(	const char* amessage,	///<  Exception Description
						long _hResult		///<  Exception Code
					) throw(): wuException(amessage){hResult = _hResult;}
			/// Copy constructor
		wuOleException(const wuOleException& other) throw() : wuException(other){hResult = other.hResult;}
			/// assignment operator=
		wuOleException& operator=(const wuOleException& other) throw(); 

		virtual const long WhatResult() const throw();

	protected:

		long hResult;
};


///
/// OleUnknownException is a type of wuOleException. It inherits from wuOleException class.
/// If you are not interested in those types of unknown exceptions it may be just caught using wuOleException.
/// This is a test comment
///

class wuOleUnknownException : public wuOleException
{

	public:	

			/// Main constructor
		wuOleUnknownException(const char* amessage, long _hResult) throw(): wuOleException(amessage, _hResult){hResult = _hResult;}
			/// Copy constructor
		wuOleUnknownException(const wuOleUnknownException& other) throw() : wuOleException(other){}
};





#endif//_WU_OLE_EXCEPTION