// last modified or checked 12 August 2002


#include <process.h> // windows threads

#ifndef _REENTRANT 
	#define _REEENTRANT
#endif



#ifndef _wuTHREAD
#define _wuTHREAD


extern "C" {	// need this external static function for archaic C-Style function requirements

	unsigned __stdcall StartThread(void* arg);

};

#define SAFE_DESTRUCTORS void _self_delete(void){delete this;}


/// wuThread class is built to mimic the operation of the Thread class found within the java
/// libraries. It is designed to make spawning of threads easy to do, as well as promoting
/// an object oriented design method. <br>
/// wuThread is a abstract class. Users must implement the function virtual void Run().
/// This function is where the thread starts from. <br>
/// One starts the thread by creating an object which is derived from wuThread, and 
/// calling Start() on it. For Example:<br><br>
/// MyThread* objMyThread = new MyThread();<br>
/// objMyThread->Start();<br><br>
/// IMPORTANT INFORMATION<br>
/// NEVER CREATE AN INSTANCE OF A THREAD ON THE STACK (local memory), ALWAYS CREATE
/// A NEW INSTANCE USING new.
/// THIS MEMORY IS THEN HELD BY THE THREAD TO MANAGE, SO MEMORY MANAGEMENT (in regards to 
/// the thread) IS NOT NEEDED AFTER CREATION OF THIS THREAD
/// THREADS CANNOT BE DIRECTLY INSTANTIATED, BUT MUST BE INHERITED BY ANOTHER CLASS
/// WHICH MUST OVERRIDE THE void run(), VIRTUAL FUNCTION MEMBER


class wuThread{

	friend unsigned __stdcall StartThread(void* arg);

//	SAFE_DESTRUCTORS

	public:

		wuThread();

		virtual ~wuThread()=0;

	// public member functions

		unsigned long Start(unsigned int initflag=0);  // place where the thread really starts.. call this when make thread (like java Thread class)
		void _Run();

	// implement these functions to derive from wuThread

		virtual void Run()=0;		///< implement this function as the point where the thread starts.
		virtual int ShutDown()=0;	///< implement this function to allow the shutdown, and exit from thread. 
									///< This function should return non-zero when successful, and zero when not successful or ignored.
		virtual int Restart()=0;	///< implement this function to allow the restart of all operations 
									///< of this thread, starting from the Run() function again. 
									///< Unlike int Shutdown(), this function should not cause the 
									///< exit of the thread. 
									///< This function should return non-zero when successful, and zero when not successful or ignored.


	protected: 

	// private member variables

		unsigned int thrdaddr; // address of the thread
		unsigned long lhThread;
};



#endif	// end of #define _wuTHREAD
