#include "winutils/wuException.h"




#ifndef _WU_WINSERVICE_EXCEPTION
#define _WU_WINSERVICE_EXCEPTION





///
/// ArrayException inherits from wuException. It is thrown by wuSafeArray for various 
/// reasons, such as invalid index error. See SafeArray and associated functions for error codes
///
class wuWinServiceException : public wuException
{

	public:	

			/// Main constructor
		wuWinServiceException(	const char* amessage,	///<  Exception Description
								unsigned long _dwResult		///<  Exception Code
						) throw(): wuException(amessage){dwResult = _dwResult;}
			/// Copy constructor
		wuWinServiceException(const wuWinServiceException& other) throw() : wuException(other){dwResult = other.dwResult;}
			/// assignment operator=
		wuWinServiceException& operator=(const wuWinServiceException& other) throw(); 

		virtual const unsigned long WhatResult() const throw();

	protected:

		unsigned long dwResult;
};




#endif//_WU_WINSERVICE_EXCEPTION