#include "winutils/wuGlobalMemory.h"
#include "winutils/wuException.h"
#include <stdio.h>


void GlobalMemory::SetupSystemGlobalData() throw()
{
	char pcharErr[1024]={0};

	// Create file mapping which can contain dwMemoryFileSize characters
    m_hFileMapping = CreateFileMapping(	INVALID_HANDLE_VALUE,           // system paging file
										NULL,                           // security attributes
										PAGE_READWRITE,                 // protection
										0,                              // high-order DWORD of size
										dwMemoryFileSize*sizeof(TCHAR), // low-order DWORD of size
										sMemoryFileName);               // name

    if ( ! m_hFileMapping )
	{
		DWORD dwErr = GetLastError();
		sprintf(pcharErr, "CreateFileMapping failed - ErrorCode = %d", dwErr);
		throw wuException(pcharErr);
    }
	else
	{
        m_pViewOfFile = MapViewOfFile(	m_hFileMapping, // handle to file-mapping object
										FILE_MAP_ALL_ACCESS,        // desired access
										0, 0, 0);                         // map all file

        if ( ! m_pViewOfFile ) throw wuException("Speech Server: fatal error -MapViewFile-");
        // Now we have m_pViewOfFile memory block which is common for
        // all instances of this program
    }
}



void GlobalMemory::CleanupSystemGlobalData(){

	if ( m_hFileMapping )
    {
        if ( m_pViewOfFile )
        {
            UnmapViewOfFile(m_pViewOfFile);
        }

        CloseHandle(m_hFileMapping);
    }
}


void GlobalMemory::GetGlobalData(char* GlobalMemory, unsigned int maxlen){

	if (maxlen>dwMemoryFileSize) maxlen = dwMemoryFileSize;

	memcpy(GlobalMemory, (char*)m_pViewOfFile, maxlen); 
}



void GlobalMemory::PutGlobalData(const char* PutGlobalMemory, unsigned int len){

	if (len>dwMemoryFileSize) len = dwMemoryFileSize;

	memcpy((char*)m_pViewOfFile, PutGlobalMemory, len); 
}

// puts a null AFTER maxlen bytes have been copied to the destination
void GlobalMemory::GetGlobalDataAsString(char* GlobalMemory, unsigned int maxlen){

	if (maxlen>dwMemoryFileSize) maxlen = dwMemoryFileSize;

	memcpy(GlobalMemory, (char*)m_pViewOfFile, maxlen); 
	GlobalMemory[maxlen]=0;
}


// puts a null AFTER maxlen bytes have been copied to the destination
void GlobalMemory::PutGlobalDataAsString(const char* PutGlobalMemory, unsigned int len){

	if (len>dwMemoryFileSize) len = dwMemoryFileSize;

	memcpy((char*)m_pViewOfFile, PutGlobalMemory, len); 
	((char*)m_pViewOfFile)[len]=0;
}


