#include "winutils/wuProgressTimeTracker.h"





wuProgressTimeTracker::wuProgressTimeTracker()
{
	ctBeginTime = 0;
}



wuProgressTimeTracker::~wuProgressTimeTracker()
{



}



void wuProgressTimeTracker::BeginTime()
{
	ctBeginTime	= clock();
}



void wuProgressTimeTracker::UpdateTime(unsigned int& uintElapsedTimeMilliSeconds, 
										unsigned int& uintEstTimeRemainingMilliSeconds,
										const unsigned int uintEstimatedTotalComputations,
										const unsigned int uintComputationsComplete)
{
	unsigned int uintMillisecondsForOneComputation = 0;
	unsigned int uintComputationsRemaining = 0;
	unsigned int _uintComputationsComplete = uintComputationsComplete;

	clock_t ctCurrentTime = clock();

	if (_uintComputationsComplete==0)
	{
		_uintComputationsComplete = 1;
	}

	uintElapsedTimeMilliSeconds = ((ctCurrentTime - ctBeginTime)*1000)/CLOCKS_PER_SEC;

	uintMillisecondsForOneComputation = uintElapsedTimeMilliSeconds / _uintComputationsComplete;

	if (uintEstimatedTotalComputations>=_uintComputationsComplete)
	{
		uintComputationsRemaining = uintEstimatedTotalComputations - _uintComputationsComplete;
	}
	else
	{
		uintComputationsRemaining = 0;
	}

	uintEstTimeRemainingMilliSeconds = uintComputationsRemaining * uintMillisecondsForOneComputation;
}


void wuProgressTimeTracker::GetPercentDone(unsigned int &PercentDone,
											const unsigned int uintElapsedTimeMilliSeconds, 
											const unsigned int uintEstTimeRemainingMilliSeconds)
{
	unsigned int _uintElapsedTimeMilliSeconds = uintElapsedTimeMilliSeconds;

	if (_uintElapsedTimeMilliSeconds==0)
	{
		_uintElapsedTimeMilliSeconds = 1;
	}

	PercentDone = (unsigned int)
					(((double)_uintElapsedTimeMilliSeconds
					/(double)(_uintElapsedTimeMilliSeconds + uintEstTimeRemainingMilliSeconds))*(double)100);
}


