#include "winutils/wuServerSocket.h"



//////////////////// ServerSocket wrapper class /////////////////////


wuServerSocket::wuServerSocket(int aport)
					:wuTCPSocket(aport)
{

}
////////////////////////



void wuServerSocket::Establish() throw (wuSocketException)
{
	try
	{
		wuSocket::Establish();
	}
	catch(wuSocketException& e)
	{
		throw wuSocketException(e.what());
	}
}


void wuServerSocket::ReEstablish(int intLocalPortNum) throw (wuSocketException)
{
	wuSocket::SetAddress(&local_addr, intLocalPortNum);

	try
	{
		wuSocket::Establish();
	}
	catch(wuSocketException& e)
	{
		throw wuSocketException(e.what());
	}
}




wuTCPSocket* wuServerSocket::Accept() throw (wuSocketException)
{
	int Sockfd = wuSocket::Accept();
	if (Sockfd<0) throw wuSocketException(wuSocketException::BADCLIENT);	
	else return new wuTCPSocket(*this);
}
/////////////////////
 



int wuServerSocket::CloseListener()
{
	return wuSocket::CloseConnector();
}



