#include "winutils/wuStdUtils.h"



using namespace std;
// sute namespace not class


int wu::Ascii2Integer(const char* str) throw (std::exception)
{

	int result = 0;
	int intSign = 1; // 1 means positive sign '+' -1 means negative
	const char* pcharInitialPos = str;	

	if (*str=='-' || *str=='+')
	{
		if (*str=='-') intSign = -1; // set it to '-' negative number
		str++; // if had a sign at start, increment to next position
	}

	while (*str >= '0' && *str <='9') 
	{
		result = (result * 10) + (*str - '0');
		str++;
	}

	if (*str != 0 || pcharInitialPos == str) throw exception("number conversion error");

	result = result * intSign; // change sign if need be

	return result;
}


double wu::Ascii2Double(const char* str) throw (std::exception)
{

	double dblresult = 0;
	int intSign = 1; // 1 means positive sign '+' -1 means negative
	int intFoundPunkt = 0;
	double dblDivisor = 10; // first decimal point (being 0.x) needs to be the result of x/10
	const char* pcharInitialPos = str;

	if (*str=='-' || *str=='+' || *str=='.')
	{
		if (*str=='-')
		{
			intSign = -1; // set it to '-' negative number
		}
	
		if (*str=='.')
		{
			intFoundPunkt = 1;
		}

		str++; // if had a sign at start, increment to next position

		if (*str =='.')
		{
			intFoundPunkt++;
		}
	}

	while ((*str >= '0' && *str <='9') || (intFoundPunkt<2 && *str=='.')) 
	{
		if (intFoundPunkt==0) // if haven't found a decimal point
		{
			dblresult = (dblresult * 10.0) + (*str - '0');
		}
		else if (*str !='.')// now in the decimal points (not in the point itself)
		{
			dblresult = dblresult + (*str - '0')/dblDivisor;
			dblDivisor = dblDivisor*10;
		}

		str++;

		if (*str =='.')
		{
			intFoundPunkt++;
		}
	}

	if (*str != 0 || pcharInitialPos == str) throw exception("number conversion error");

	dblresult = dblresult * intSign; // change sign if need be

	return dblresult;
}



size_t wu::strlcpy(char *dst, const char *src, size_t size)
{
	size_t uintSrcSize = strlen(src) +1;

	if (uintSrcSize<size)
	{
		size = uintSrcSize;
	}

	// copy the string, allowing room for the null at the end
	for (unsigned int uintCounter = 0;uintCounter<size-1;uintCounter++)
	{
		dst[uintCounter] = src[uintCounter];
	}
	
	// add the null to the end of the string
	dst[uintSrcSize-1] = 0;

	return uintSrcSize-1;
}


