#include "winutils/wuStokenizer.h"


 
using namespace std;

wuStokenizer::wuStokenizer(string tt, string dels, bool _IgnoreQuotes)
{
	totok= tt;
	delims = dels;
	IgnoreQuotes = _IgnoreQuotes;

	restore();
}



bool wuStokenizer::more()
{
	return  (totok.length()>=pos+1);
}



string wuStokenizer::next()
{
	string use="";
	lastDelims="";

	if (!more()) 
	{
		return use;
	}

	while((pos<totok.length()) && charindelim(totok[pos]))// these lines FIX a issue (if delim at start, 
	{	
		lastDelims = lastDelims + totok[pos]; // record the last string of delimeters
		pos++;									//first token not returned until second call to more())
	}

	while ((pos<totok.length()) && (!charindelim(totok[pos]) || (WithinQuotes && !IgnoreQuotes)))
	{
		use= use+totok[pos];
		if (totok[pos]=='"') WithinQuotes = !WithinQuotes;	// if see a quote, toggle the indicator
		pos++;
	}

	while((pos<totok.length()) && charindelim(totok[pos]))
	{
		lastDelims = lastDelims + totok[pos]; // record the last string of delimeters
		pos++;
	}

	return use;
}


string wuStokenizer::NextUntil(char tokEnd, bool including)
{
	string use="";
	lastDelims="";
	bool SeenDelims = false; // keep track of last delims


	while ((pos<totok.length()) && totok[pos]!= tokEnd)
	{
		use= use+totok[pos];
		if (totok[pos]=='"') WithinQuotes = !WithinQuotes;	// if see a quote, toggle the indicator
		if (!charindelim(totok[pos])) lastDelims="";
		else lastDelims = lastDelims + totok[pos]; // record the last string of delimeters
		pos++;
	}

	if (pos<totok.length() && including)
	{ // if must include tokEnd, add to string + inc position counter
		use = use + totok[pos];
		if (totok[pos]=='"')
		{
			WithinQuotes = !WithinQuotes;	// if see a quote, toggle the indicator
		}

		pos++;
	}

	return use;
}




string wuStokenizer::toLowerCase(string word){

	for (unsigned int i=0;i<word.length();i++)
	{
		word[i] = tolower(word[i]);
	}

	return word;
}

string wuStokenizer::toUpperCase(string word){

	for (unsigned int i=0;i<word.length();i++)
	{
		word[i] = toupper(word[i]);
	}

	return word;
}



int wuStokenizer::charindelim(const char letter)
{

	int isin=0;
	for (unsigned int i =0;i<delims.length();i++)
	{
		isin= (letter==delims[i])*1 +(letter!=delims[i])*isin;
	}

	return isin;
}




void wuStokenizer::restore()
{
	lastDelims="";
	pos=0;
	WithinQuotes = false; // initially cannot be in a quote if this is the start of a tokenizer line
							// this line only takes affect if 'IgnoreQuotes' is false
	if (! (more() && next()!=""))
	{
		pos = totok.length();
	}
	else
	{
		lastDelims="";
		pos=0;
		WithinQuotes = false; 		
	}
}


string wuStokenizer::UnTokenizedString()
{
	string RestOfString = (char*)(&totok[pos]);
	return RestOfString;	// return that section of the string which is
}							// on the right side of the position counter
							// starting with current position

string wuStokenizer::GetLastDelims()
{
	return lastDelims;
}


string wuStokenizer::trim(string totrim)
{
	string Whitespace = " \t\r\v\n";

	int right = totrim.find_last_not_of(Whitespace);
	int left  = totrim.find_first_not_of(Whitespace);
	
	if (totrim.length()<1) return "";
	if (right<0 && left<0) return ""; // if there is nothing but whitespace
	if (left<0) left=0;
	if (right>=totrim.length()) right = totrim.length();

	return totrim.substr(left, right-left+1);
}



