#include "winutils/wuSysLogSet.h"






wuSysLogSet::wuSysLogSet()
{

}





wuSysLogSet::~wuSysLogSet()
{
	ClearSet();
}





void wuSysLogSet::ClearSet()
{
	LoggerListType::iterator objIter = LoggerList.begin();
	wuSysLogger* pTempLogger = 0;

	while (objIter != LoggerList.end())
	{
		pTempLogger = objIter->second.mSysLogger;
	
		if (objIter->second.mblnCleanupSysLogger) // if cleanup requested and noted within the map entry for this logger
		{
			try
			{
				delete pTempLogger;
			}
			catch(...)
			{
			}
		}

		objIter++;
	}

	LoggerList.clear();
}


/*
struct SysLoggerInfo
{
	wuSysLogger* SysLogger;
	bool mblmCleanupSysLogger;
};

//					logger, cleanup on list deletion?
typedef std::multimap<std::string, SysLoggerInfo> LoggerListType;
*/


void wuSysLogSet::Add(wuSysLogger* Logger, bool blnCleanup)
{
	LoggerList.insert(LoggerListType::value_type("" ,SysLoggerInfo(Logger, blnCleanup)));
}


void wuSysLogSet::Add(std::string strLoggerKey, wuSysLogger* Logger, bool blnCleanup)
{
	LoggerList.insert(LoggerListType::value_type(strLoggerKey ,SysLoggerInfo(Logger, blnCleanup)));
}



void wuSysLogSet::Initialise(	const char* cpcharProcName, 
								unsigned int uintWinsockSigVersNum, 
								unsigned int uintWinsockInsigVersNum)
{
	LoggerListType::iterator objIter = LoggerList.begin();
	wuSysLogger* pTempLogger = 0;

	while (objIter != LoggerList.end())
	{
		pTempLogger = objIter->second.mSysLogger;
	
		try
		{
			pTempLogger->Initialise(cpcharProcName, uintWinsockSigVersNum, uintWinsockInsigVersNum);
		}
		catch(...)
		{
		}

		objIter++;
	}
}








// log to only those loggers identified by strLoggerKey, and those not with no defined key
bool wuSysLogSet::Log(	std::string strLoggerKey,
						SysLogFacilityCode Facility, 
						SysLogSeverityCode Severity, 
						const char* cpcharMessageContent)
{
	std::pair<LoggerListType::const_iterator, LoggerListType::const_iterator> LogListPair = 
							LoggerList.equal_range(strLoggerKey);

	LoggerListType::const_iterator objIter = LogListPair.first;

	while(objIter!=LogListPair.second)
	{
		Log(objIter->second.mSysLogger, Facility, Severity, cpcharMessageContent);
		objIter++;
	}

	// now the no key
	LogListPair = LoggerList.equal_range("");

	objIter = LogListPair.first;

	while(objIter!=LogListPair.second)
	{
		Log(objIter->second.mSysLogger, Facility, Severity, cpcharMessageContent);
		objIter++;
	}

	return true;
}





// log to all
bool wuSysLogSet::Log(	SysLogFacilityCode Facility, 
						SysLogSeverityCode Severity, 
						const char* cpcharMessageContent)
{

	LoggerListType::iterator objIter = LoggerList.begin();

	while (objIter != LoggerList.end())
	{
		Log(objIter->second.mSysLogger, Facility, Severity, cpcharMessageContent);
		objIter++;
	}

	return true;
}







bool wuSysLogSet::Log(	wuSysLogger* TheLogger,
						SysLogFacilityCode Facility, 
						SysLogSeverityCode Severity, 
						const char* cpcharMessageContent)
{
	try
	{
		TheLogger->Log(Facility, Severity, cpcharMessageContent);
	}
	catch(...)
	{
	}

	return true;
}
