#include "winutils/wuSysLogUDPSocket.h"
#include "winutils/wuSYSTEMTIME.h"
#include <string>


using namespace std;



wuSysLogUDPSocket::wuSysLogUDPSocket()
{
	SetOptions(syslgDebug);
}



wuSysLogUDPSocket::wuSysLogUDPSocket(	const char* pcharAppName,
										SysLogSeverityCode LoggingInsignificance,
										unsigned int uintWinsockSignificantVersNum=2, 
										unsigned int uintWinsockInsignificantVersNum=2)
{
	SetOptions(LoggingInsignificance);
	wuSysLogger::Initialise(pcharAppName, 2, 2);
}




// this function is called by the wuSysLogger class
bool wuSysLogUDPSocket::Log(const char* LogString)
{
	int intStrLen = strlen(LogString);
	int intSent = Send(LogString, intStrLen);	
	bool blnReturn = false;

	if (intSent>0)
	{
		blnReturn = true;
	}

	return blnReturn;
}



// We override this function so we can tailor the message content
bool wuSysLogUDPSocket::Log(	SysLogFacilityCode Facility, 
								SysLogSeverityCode Severity, 
								const char* cpcharMessageContent)
{
	bool			blnReturn = false;
	string			strOutput = "";
	unsigned long	lngPreviousDate = 0;	// date that file was last written or accessed
	SYSTEMTIME		lCurrentSystemTime;

	char pcharDateBuffer[10]={0};
	char pcharTimeBuffer[10]={0};

	GetLocalTime(&lCurrentSystemTime);

	wuSYSTEMTIME::FormatDate(pcharDateBuffer, 10, "DD/MM/YY", lCurrentSystemTime);
	wuSYSTEMTIME::FormatDate(pcharTimeBuffer, 10, "hh:mm:ss", lCurrentSystemTime);


		// construct the log msg
	if (Severity<=mLoggingInsignificance)
	{
		// construct the message
		strOutput = (string)pcharDateBuffer + ";" + 
					(string)pcharTimeBuffer + ";" + 
					"Facility:" + cpcharFacility[Facility] + ";" +
					"Severity:" + cpcharSeverity[Severity] + ";" + cpcharMessageContent;

		blnReturn = wuSysLogger::Log(Facility, Severity, strOutput.c_str());
	}

	return blnReturn;
}






void wuSysLogUDPSocket::SetOptions(SysLogSeverityCode	LoggingInsignificance)
{
	mLoggingInsignificance = LoggingInsignificance;
}


